﻿' Press F11 to fold all in Jungle IDE

'#Region Imports
Import mojo
Import fontmachine
Import "Data/Arial10.txt"
Import "Data/Arial10_P_1.png"
Import "Data/Arial10B.txt"
Import "Data/Arial12.txt"
Import "Data/Arial10B_P_1.png"
Import "Data/Arial12_P_1.png"
Import "Data/Arial20B.txt"
Import "Data/Arial22.txt"
Import "Data/Arial20B_P_1.png"
Import "Data/Arial22_P_1.png"
Import "Data/GUI_mac.png"
Import "Data/Shadow.png"
'#EndRegion 


'#Region Globals
Public

	'summary: Returns the FPS
Global CHGUI_FPS
	#Rem
	summary: The image used to 'skin' the gui
	[code]CHGUI_Style = LoadImage("Mystyle.png")[/code]
	#End
Global CHGUI_Style:Image
	#Rem
summary: Shadow toggle
[code]CHGUI_Shadow = 1 'Turns the shadow system on
CHGUI_Shadow = 0 'Turns the shadow system off[/code]
#End
Global CHGUI_Shadow = 1
	'summary: Mobile mode toggle - (This Increases Non custom font sizes and titlebar height etc)
Global CHGUI_MobileMode = 0
	'summary: Keyboard option - (0= No Keyboard - 1= Onboard Keyboard - 2= Custom Keyboard)
Global CHGUI_Keyboard = 1
	'summary: Drag scroll toggle - (0= No scroll - 1= Click and drag on an empty space to scroll entire gui)
Global CHGUI_DragScroll = 0
	'summary: Auto Textfield Scroll toggle - (0= No scroll - 1= When you click on a textfield it moves the gui up from under the onscreen keyboard)
Global CHGUI_AutoTextScroll=0
	'summary: Sets the height of the titlebars
Global CHGUI_TitleHeight:Float = 25
	'summary: Sets the overall X position of the entire GUI
Global CHGUI_OffsetX:Float
	'summary: Sets the overall Y position of the entire GUI
Global CHGUI_OffsetY:Float
	#Rem
	summary: Used to set a custom font (to make fonts you will need to buy Font Machine Editor)
	[code]CHGUI_Font = BitmapFont.Load("mistral.txt",True)[/code]
	#End
Global CHGUI_Font:BitmapFont
	#Rem
summary: Used to set a custom titlebar font (to make fonts you will need to buy Font Machine Editor)
[code]CHGUI_TitleFont = BitmapFont.Load("Arial10BW.txt",True)[/code]
#End
Global CHGUI_TitleFont:BitmapFont
	#Rem
summary: Used to control entire gui in one go
[code]CHGUI_Canvas.Visible = 0[/code]
#End

Global CHGUI_Canvas:CHGUI
	#Rem
summary: Used to set a custom Tooltip font (to make fonts you will need to buy Font Machine Editor)
[code]CHGUI_TooltipFont = BitmapFont.Load("Arial8.txt",True)[/code]
#End
Global CHGUI_TooltipFont:BitmapFont
	'summary: Returns 1 if the mouse is being used by the gui system
Global CHGUI_MouseBusy
'summary: Tooltips toggle - (0= No tooltips - 1= Display tooltips)
Global CHGUI_Tooltips = 1
	#Rem
	summary: Return / Set the amount of time in Millisecs before the tooltip Shows
	#End
Global CHGUI_TooltipTime = 1500
'summary: Returns 1 if the mouse is over any gui element
Global CHGUI_Over
'summary: Returns 1 if the gui system is receiving text input
Global CHGUI_TextboxOnFocus

'summary: Sets / Returns the Width of the gui area (Defaults to devicewidth() if not set)
Global CHGUI_Width
'summary: Sets / Returns the Width of the gui area (Defaults to devicewidth() if not set)
Global CHGUI_Height

Private

Global CHGUI_TooltipFlag:CHGUI
Global CHGUI_ShadowImg:Image
Global CHGUI_Millisecs
Global CHGUI_FPSCounter
Global CHGUI_TopList:CHGUI[]
Global CHGUI_VariList:CHGUI[]
Global CHGUI_BottomList:CHGUI[]
Global CHGUI_TopVari:CHGUI 
Global CHGUI_TopTop:CHGUI
Global CHGUI_MenuOver
Global CHGUI_MenuClose
Global CHGUI_LockedWIndow:CHGUI
Global CHGUI_Started
Global CHGUI_CanvasFlag
Global CHGUI_OldX:Float
Global CHGUI_OldY:Float
Global CHGUI_TargetX:Float
Global CHGUI_TargetY:Float
Global CHGUI_Moving
Global CHGUI_TextBoxOver
Global CHGUI_TextBoxDown
Global CHGUI_DragOver
Global CHGUI_DragMoving
Global CHGUI_OffsetMX:Float
Global CHGUI_OffsetMY:Float
Global CHGUI_KeyboardWindow:CHGUI
Global CHGUI_KeyboardButtons:CHGUI[109]
Global CHGUI_ShowKeyboard = 0
Global CHGUI_KeyboardPage = 0
Global CHGUI_KeyboardShift = 0
Global CHGUI_KeyboardEnterPress = 0
Global CHGUI_OverFlag
Global CHGUI_DownFlag

Global CHGUI_ShiftHold
Global CHGUI_IgnoreMouse
Global CHGUI_TextboxFocus:CHGUI
Global CHGUI_Cursor
Global CHGUI_CursorMillisecs
Global CHGUI_MsgBoxWindow:CHGUI
Global CHGUI_MsgBoxLabel:CHGUI
Global CHGUI_MsgBoxButton:CHGUI
'#EndRegion 

Public

'summary: Class used for creation of all gui elements
Class CHGUI
	'summary: Sets / Returns the X position of gui element
	Field X:Float
	'summary: Sets / Returns the Y position of gui element
	Field Y:Float
	'summary: Sets / Returns the Width of gui element
	Field W:Float
	'summary: Sets / Returns the Height of gui element
	Field H:Float
	'summary: Sets / Returns the visibility of gui element
	Field Visible=1
	'summary: Sets / Returns the active flag of gui element
	Field Active=1
	'summary: Sets / Returns the text of gui element (button text, window title text, etc)
	Field Text:String
	'summary: Returns 1 when the mouse is over gui element
	Field Over
	'summary: Returns 1 when the mouse is Down on gui element
	Field Down
	'summary: Returns how long the mouse has been over an element in millisecs
	Field OverTime
	'summary: Returns how long the mouse button has been Down on an element in millisecs
	Field DownTime
	'summary: Returns 1 when a gui element is clicked
	Field Clicked
	'summary: Returns 1 when a gui element is Double Clicked
	Field DoubleClicked
	'summary: Sets / Returns the value of gui element (0/1 for tickbox, Value of slider etc)
	Field Value:Float
	'summary: Sets / Returns whether a window has a close button
	Field Close
	'Field Closed
	'summary: Sets / Returns whether a window has a minimise button
	Field Minimise
	'summary: Sets / Returns whether a window is minimised
	Field Minimised
	'summary: Sets / Returns whether a window is moveable
	Field Moveable
	'summary: Returns 1 if a window is moving
	Field Moving
	'summary: Sets / Returns a window order mode (0= Always behind - 1= Variable - 2= Always on top)
	Field Mode
	'summary: Sets / Returns an individual window shadow - Only visible if CHGUI_Shadow = 1 (0= No Shadow - 1= Shadow)
	Field Shadow=0
	'summary: Sets / Returns which group from a radio box
	Field Group
	#Rem
	summary: Image for the image button (Image needs to have 4 'frames', Normal, Over, Down and Inactive)
	[code]MyButton = CreateImageButton(50,160,LoadImage("Button.png"),MainWindow)[/code]
	#End
	Field Img:Image
	'summary: Sets / Returns if a menu has a tickbox
	Field Tick
	'summary: Sets / Returns a slider minimum value
	Field Minimum:Float
	'summary: Sets / Returns a slider maximum value
	Field Maximum:Float
	'summary: Sets / Returns a windows crrent tab
	Field CurrentTab:CHGUI
	#Rem
	summary: Used to set an elements Tooltip - "" = No Tooltip
	[code]MyButton.Tooltip = "This is a Tooltip"[/code]
	#End
	Field Tooltip:String
	Field MX:Float, MY:Float
	
	Private
	Field ListboxNumber
	Field StartOvertime
	Field StartDowntime
	Field SelectedListboxItem:CHGUI
	Field MinimiseOver
	Field MinimiseDown
	Field CloseOver
	Field CloseDown
	Field Parent:CHGUI
	Field IsParent
	Field OnFocus
	Field Element:String
	Field TopTop:CHGUI
	Field TopBottom:CHGUI
	Field HasMenu
	Field MenuHeight
	Field MenuActive:CHGUI
	Field ReOrdered
	Field DKeyMillisecs
	Field SubWindow
	Field TopVari:CHGUI
	Field DClickMillisecs
	Field IsMenuParent
	Field MenuWidth
	Field MenuOver:CHGUI
	Field MenuNumber
	Field DropNumber
	Field SWidth:Float
	Field Stp:Float
	Field MinusOver
	Field PlusOver
	Field MinusDown
	Field PlusDown
	Field SliderOver
	Field SliderDown
	Field Start
	Field Cursor
	Field Tabbed
	Field TabHeight
	Field ListHeight
	Field ListboxSlider:CHGUI
	Field Buttons:CHGUI[]
	Field ImageButtons:CHGUI[]
	Field Tickboxes:CHGUI[]
	Field Radioboxes:CHGUI[]
	Field Dropdowns:CHGUI[]
	Field Menus:CHGUI[]
	Field TopList:CHGUI[]
	Field VariList:CHGUI[]
	Field BottomList:CHGUI[]
	Field HSliders:CHGUI[]
	Field VSliders:CHGUI[]
	Field Textfields:CHGUI[]
	Field Tabs:CHGUI[]
	Field Labels:CHGUI[]
	Field DropdownItems:CHGUI[]
	Field MenuItems:CHGUI[]
	Field Listboxes:CHGUI[]
	Field ListboxItems:CHGUI[]
	Field DoubleClickMillisecs
	
	Field FormatNumber = 1
	Field FormatText = 1
	Field FormatSymbol = 1
	Field FormatSpace = 1
	
	'Check Over Method
	Method CheckOver()
	If Minimised =0 Then
		If Self <> CHGUI_Canvas
			Local XX = CHGUI_RealX(Self)
			Local YY = CHGUI_RealY(Self)
			
			If CHGUI_OverFlag = 0 And CHGUI_IgnoreMouse = 0 And TouchX()>XX And TouchX()<XX+W And TouchY()>YY And TouchY()<YY+H Then
				Over = 1
				CHGUI_Over = 1
				CHGUI_OverFlag = 1
				If Element <> "Window" Then CHGUI_DragOver = 1
				OverTime = Millisecs() - StartOvertime
			Else
				Over = 0
				OverTime = 0
				StartOvertime = Millisecs()
			End If
		End If	
	Else
		If Self <> CHGUI_Canvas
			Local XX = CHGUI_RealX(Self)
			Local YY = CHGUI_RealY(Self)
			If CHGUI_OverFlag = 0 And CHGUI_IgnoreMouse = 0 And TouchX()>XX And TouchX()<XX+W And TouchY()>YY And TouchY()<YY+CHGUI_TitleHeight Then
				Over = 1
				CHGUI_Over = 1
				CHGUI_OverFlag = 1
				OverTime = Millisecs() - StartOvertime
			Else
				Over = 0
				OverTime = 0
				StartOvertime = Millisecs()
				
			End If
		End If	
	End If
	End Method
	
	'Check Down Method
	Method CheckDown()
		If Over And TouchDown() And CHGUI_MouseBusy = 0 Or Down=1
				CHGUI_DownFlag = 1
				CHGUI_MouseBusy = 1
				Down = 1
				If Element <> "Window" Then CHGUI_DragOver = 1
				DownTime = Millisecs() - StartDowntime
				StartOvertime = Millisecs()
		End If
		If TouchDown() = 0 Then
			Down = 0
			DownTime = 0
			StartDowntime = Millisecs()
		End If
		If Over = 1 And TouchDown() Then
			If Down = 0 Then Over = 0
		End If
		'ReOrder Windows
		If Down Then
			If Mode = 1 CHGUI_Reorder(Self)
				Local E:CHGUI = Self
				Repeat
					If E.Parent <> Null
						If E.Parent.Element = "Window" And E.Parent.Mode = 1 Then
							CHGUI_Reorder(E.Parent)
						End If
						E = E.Parent	
					Else
						Exit
					End If
				Forever
		End If
	End Method
	
	'Check Clicked Method
	Method CheckClicked()
		If CHGUI_RealActive(Self)=0 Or CHGUI_RealVisible(Self)=0 Then
			Over = 0
			Down = 0
			Clicked = 0
		End If
		If Over And Down And TouchDown() = 0 Then
			Clicked = 1
		Else
			Clicked = 0
		End If
		'Double Clicked
		
		If Clicked Then
			If Millisecs() < DoubleClickMillisecs Then DoubleClicked = 1
			DoubleClickMillisecs = Millisecs + 275
		Else
			DoubleClicked = 0
		End If
		
		
	End Method
End Class


'#Region Creation Functions

'summary: Used to create a window - Mode: (1= Always Behind - 2= Variable - 3= Always on top)
Function CreateWindow:CHGUI(X, Y, W, H, Title:String, Moveable=1, CloseButton=1, MinimiseButton=1, Mode = 1, Parent:CHGUI=Null)
	If CHGUI_Started = 0 Then
		CHGUI_Started = 1
		CHGUI_Start()
	End If
	Local N:CHGUI = New CHGUI
	N.X = X
	N.Y = Y
	N.W = W
	N.H = H
	N.Text = Title
	N.Shadow = CHGUI_Shadow
	N.Close = CloseButton
	N.Minimise = MinimiseButton
	N.Moveable = Moveable
	N.Mode = Mode
	N.Parent = Parent
	If N.Parent = Null Then N.Parent = CHGUI_Canvas
	If N.Parent <> NUll Then N.Parent.IsParent = 1
	N.Element = "Window"
	If CHGUI_CanvasFlag=1 Then
		If Mode = 0 Then
			CHGUI_BottomList = CHGUI_BottomList.Resize(CHGUI_BottomList.Length + 1)
			CHGUI_BottomList[CHGUI_BottomList.Length - 1] = N
		End If
		If Mode = 1 Then
			CHGUI_VariList = CHGUI_VariList.Resize(CHGUI_VariList.Length + 1)
			CHGUI_VariList[CHGUI_VariList.Length - 1] = N
		End If
		If Mode = 2 Then
			CHGUI_TopList = CHGUI_TopList.Resize(CHGUI_TopList.Length + 1)
			CHGUI_TopList[CHGUI_TopList.Length - 1] = N
			CHGUI_TopTop = N
		End If
	Else
		N.SubWindow = 1
		If Mode = 0 Then
			N.Parent.BottomList = N.Parent.BottomList.Resize(N.Parent.BottomList.Length + 1)
			N.Parent.BottomList[N.Parent.BottomList.Length - 1] = N
		End If
		If Mode = 1 Then
			N.Parent.VariList = N.Parent.VariList.Resize(N.Parent.VariList.Length + 1)
			N.Parent.VariList[N.Parent.VariList.Length - 1] = N
		End If
		If Mode = 2 Then
			N.Parent.TopList = N.Parent.TopList.Resize(N.Parent.TopList.Length + 1)
			N.Parent.TopList[N.Parent.TopList.Length - 1] = N
		End If
	End If
	
	Return N
End Function

'summary: Used to create a button - Optional Parent can be a window or a tab
Function CreateButton:CHGUI(X, Y, W, H, Text:String, Parent:CHGUI = Null)
	If CHGUI_Started = 0 Then
		CHGUI_Started = 1
		CHGUI_Start()
	End If
	Local N:CHGUI = New CHGUI
	N.Parent = Parent
	If Parent = Null Then N.Parent = CHGUI_Canvas
	N.X = X
	N.Y = Y
	N.W = W
	N.H = H
	N.Text = Text
	N.Element = "Button"
	'Add to List
	N.Parent.Buttons = N.Parent.Buttons.Resize(N.Parent.Buttons.Length + 1)
	N.Parent.Buttons[N.Parent.Buttons.Length - 1] = N
	Return N
End Function

'summary: Used to create a tickbox - Optional Parent can be a window or a tab
Function CreateTickbox:CHGUI(X, Y, H, Text:String, Parent:CHGUI = Null)
	If CHGUI_Started = 0 Then
		CHGUI_Started = 1
		CHGUI_Start()
	End If
	Local N:CHGUI = New CHGUI
	N.Parent = Parent
	If Parent = Null Then N.Parent = CHGUI_Canvas
	N.X = X
	N.Y = Y
	N.H = H
	N.Text = Text
	N.Element = "Tickbox"
	'Add to List
	N.Parent.Tickboxes = N.Parent.Tickboxes.Resize(N.Parent.Tickboxes.Length + 1)
	N.Parent.Tickboxes[N.Parent.Tickboxes.Length - 1] = N
	Return N

End Function

'summary: Used to create a radio - Optional Parent can be a window or a tab
Function CreateRadio:CHGUI(X, Y, H, Text:String, Group, Parent:CHGUI = Null)
	If CHGUI_Started = 0 Then
		CHGUI_Started = 1
		CHGUI_Start()
	End If
	Local N:CHGUI = New CHGUI
	N.Parent = Parent
	If Parent = Null Then N.Parent = CHGUI_Canvas
	N.X = X
	N.Y = Y
	N.H = H
	N.Text = Text
	N.Group = Group
	N.Element = "Radio"
	'Add to List
	N.Parent.Radioboxes = N.Parent.Radioboxes.Resize(N.Parent.Radioboxes.Length + 1)
	N.Parent.Radioboxes[N.Parent.Radioboxes.Length - 1] = N
	Return N
End Function

'summary: Used to create a Dropdown box - Optional Parent can be a window or a tab
Function CreateDropdown:CHGUI(X, Y, W, H, Text:String, Parent:CHGUI = Null)
	If CHGUI_Started = 0 Then
		CHGUI_Started = 1
		CHGUI_Start()
	End If
	Local N:CHGUI = New CHGUI
	N.Parent = Parent
	If N.Parent = Null Then N.Parent = CHGUI_Canvas
	N.X = X
	N.Y = Y
	N.H = H
	N.W =W
	N.Text = Text
	N.Element = "Dropdown"
	'Add to List
	N.Parent.Dropdowns = N.Parent.Dropdowns.Resize(N.Parent.Dropdowns.Length + 1)
	N.Parent.Dropdowns[N.Parent.Dropdowns.Length - 1] = N
	Return N
End Function

'summary: Used to add a Dropdown Item - Dropdown is a created DropdownBox (:CHGUI) - Optional value transfers a value as well as the text to the parent DropdownBox
Function CreateDropdownItem:CHGUI(Text:String, Dropdown:CHGUI, Value = 0)
	Local N:CHGUI = New CHGUI
	N.Parent = Dropdown
	
	N.Value = Value
	N.Text = Text
	N.Element = "DropdownItem"
	'Add to List
	N.Parent.DropdownItems = N.Parent.DropdownItems.Resize(N.Parent.DropdownItems.Length + 1)
	N.Parent.DropdownItems[N.Parent.DropdownItems.Length - 1] = N
	Return N

End Function

'summary: Used to create an Image button - Image must have 4 frames (Normal, Over, Down, Inactive) - Optional Parent can be a window or a tab
Function CreateImageButton:CHGUI(X, Y, Img:Image, Parent:CHGUI = Null)
	If CHGUI_Started = 0 Then
		CHGUI_Started = 1
		CHGUI_Start()
	End If
	Local N:CHGUI = New CHGUI
	N.Parent = Parent
	If Parent = Null Then N.Parent = CHGUI_Canvas
	N.X = X
	N.Y = Y
	N.W = Img.Width()/4
	N.H = Img.Height()
	N.Img = Img
	N.Element = "ImageButton"
	'Add to List
	N.Parent.ImageButtons = N.Parent.ImageButtons.Resize(N.Parent.ImageButtons.Length + 1)
	N.Parent.ImageButtons[N.Parent.ImageButtons.Length - 1] = N
	Return N
End Function

'summary: Used to create a Top level Menu - Optional Parent can be a window or a tab
Function CreateMenu:CHGUI(Text:String, Parent:CHGUI=Null)
	If CHGUI_Started = 0 Then
		CHGUI_Started = 1
		CHGUI_Start()
	End If
	Local N:CHGUI = New CHGUI
	N.Parent = Parent
	N.Text = Text
	N.Element = "Menu"
	If Parent = Null Then N.Parent = CHGUI_Canvas
	'Add to List
	N.Parent.Menus = N.Parent.Menus.Resize(N.Parent.Menus.Length + 1)
	N.Parent.Menus[N.Parent.Menus.Length - 1] = N
	Return N

End Function

'summary: Used to add a menu item - Parent has to be a Top level menu or other submenu - Tick (0= No tickbox - 1= Tickbox)
Function CreateMenuItem:CHGUI(Text:String, Parent:CHGUI, Tick=0)
	If CHGUI_Started = 0 Then
		CHGUI_Started = 1
		CHGUI_Start()
	End If
	Local N:CHGUI = New CHGUI
	N.Parent = Parent
	N.Text = Text
	N.Element = "MenuItem"
	N.Tick = Tick
	If N.Parent.Element = "MenuItem" Then
		N.Parent.IsMenuParent = 1
	End If
	'Add to List
	N.Parent.MenuItems = N.Parent.MenuItems.Resize(N.Parent.MenuItems.Length + 1)
	N.Parent.MenuItems[N.Parent.MenuItems.Length - 1] = N
	Return N

End Function

'summary: Used to create a horizontal slider - Optional Parent can be a window or a tab
Function CreateHSlider:CHGUI(X, Y, W, H, Minimum, Maximum, Parent:CHGUI = Null)
	If CHGUI_Started = 0 Then
		CHGUI_Started = 1
		CHGUI_Start()
	End If
	Local N:CHGUI = New CHGUI
	N.Parent = Parent
	If Parent = Null Then N.Parent = CHGUI_Canvas
	N.X = X
	N.Y = Y
	N.W = W
	N.H = H
	N.Minimum = Minimum
	N.Maximum = Maximum
	N.Element = "HSlider"
	'Add to List
	N.Parent.HSliders = N.Parent.HSliders.Resize(N.Parent.HSliders.Length + 1)
	N.Parent.HSliders[N.Parent.HSliders.Length - 1] = N
	Return N
End Function

'summary: Used to create a vertical slider - Optional Parent can be a window or a tab
Function CreateVSlider:CHGUI(X, Y, W, H, Minimum, Maximum, Parent:CHGUI = Null)
	If CHGUI_Started = 0 Then
		CHGUI_Started = 1
		CHGUI_Start()
	End If
	Local N:CHGUI = New CHGUI
	N.Parent = Parent
	If Parent = Null Then N.Parent = CHGUI_Canvas
	N.X = X
	N.Y = Y
	N.W = W
	N.H = H
	N.Minimum = Minimum
	N.Maximum = Maximum
	N.Element = "VSlider"
	'Add to List
	N.Parent.VSliders = N.Parent.VSliders.Resize(N.Parent.VSliders.Length + 1)
	N.Parent.VSliders[N.Parent.VSliders.Length - 1] = N
	Return N
End Function

'summary: Used to create a textfield - Optional Parent can be a window or a tab
Function CreateTextfield:CHGUI(X, Y, W, H, Text:String, Parent:CHGUI = Null)
	If CHGUI_Started = 0 Then
		CHGUI_Started = 1
		CHGUI_Start()
	End If
	Local N:CHGUI = New CHGUI
	N.Parent = Parent
	If Parent = Null Then N.Parent = CHGUI_Canvas
	N.X = X
	N.Y = Y
	N.W = W
	N.H = H
	N.Text = Text
	N.Element = "Textfield"
	'Add to List
	N.Parent.Textfields = N.Parent.Textfields.Resize(N.Parent.Textfields.Length + 1)
	N.Parent.Textfields[N.Parent.Textfields.Length - 1] = N
	Return N
End Function

'summary: Used to create a Tab - Optional Parent has to be a window
Function CreateTab:CHGUI(Title:String, Window:CHGUI=Null)
	If CHGUI_Started = 0 Then
		CHGUI_Started = 1
		CHGUI_Start()
	End If
	Local N:CHGUI = New CHGUI

	N.Text = Title
	'N.Shadow = CHGUI_Shadow
	N.Parent = Window
	If N.Parent = Null Then N.Parent = CHGUI_Canvas
	N.Element = "Tab"
	If N.Parent.Tabbed = 0 Then
		N.Parent.Tabbed = 1
		N.Parent.CurrentTab = N
	End If
	N.Parent.Tabs = N.Parent.Tabs.Resize(N.Parent.Tabs.Length + 1)
	N.Parent.Tabs[N.Parent.Tabs.Length - 1] = N

	Return N
End Function

'summary: Used to create a label - Optional Parent can be a window or a tab
Function CreateLabel:CHGUI(X, Y, Text:String, Parent:CHGUI = Null)
	If CHGUI_Started = 0 Then
		CHGUI_Started = 1
		CHGUI_Start()
	End If
	Local N:CHGUI = New CHGUI
	N.Parent = Parent
	If Parent = Null Then N.Parent = CHGUI_Canvas
	N.X = X
	N.Y = Y
	N.Text = Text
	
	N.Element = "Label"
	'Add to List
	N.Parent.Labels = N.Parent.Labels.Resize(N.Parent.Labels.Length + 1)
	N.Parent.Labels[N.Parent.Labels.Length - 1] = N
	Return N
End Function

'summary: Used to create a Listbox - Optional Parent can be a window or a tab
Function CreateListbox:CHGUI(X, Y, W, H, Parent:CHGUI = Null)
	If CHGUI_Started = 0 Then
		CHGUI_Started = 1
		CHGUI_Start()
	End If
	Local N:CHGUI = New CHGUI
	N.Parent = Parent
	If Parent = Null Then N.Parent = CHGUI_Canvas
	N.X = X
	N.Y = Y
	N.W = W
	N.H = H
	
	N.Element = "Listbox"
	
	N.ListboxSlider = CreateVSlider(X+W-17,Y,17,H,0,10,N.Parent)
	'Add to List
	N.Parent.Listboxes = N.Parent.Listboxes.Resize(N.Parent.Listboxes.Length + 1)
	N.Parent.Listboxes[N.Parent.Listboxes.Length - 1] = N
	Return N
End Function

'summary: Used to create a ListboxItem - Parent has to be a Listbox
Function CreateListboxItem:CHGUI(Text:String,  Parent:CHGUI, Value = 0)
	If CHGUI_Started = 0 Then
		CHGUI_Started = 1
		CHGUI_Start()
	End If
	Local N:CHGUI = New CHGUI
	N.Parent = Parent
	N.Text = Text
	N.Value = Value
	
	N.Element = "ListboxItem"
	
	'Add to List
	N.Parent.ListboxItems = N.Parent.ListboxItems.Resize(N.Parent.ListboxItems.Length + 1)
	N.Parent.ListboxItems[N.Parent.ListboxItems.Length - 1] = N
	Return N
End Function

'#EndRegion

'summary: Place in OnUpdate() method to Update the gui system
Function CHGUI_Update()
	'Reset Flags
	If TouchDown() = 0 Then CHGUI_MouseBusy = 0
	CHGUI_Over = 0
	CHGUI_OverFlag = 0
	CHGUI_DownFlag = 0
	CHGUI_MenuOver = 0
	CHGUI_TextBoxOver = 0
	CHGUI_TextboxOnFocus = 0
	CHGUI_TextBoxDown = 0
	CHGUI_DragOver = 0
	CHGUI_TooltipFlag = Null
	If CHGUI_Canvas <> Null Then
		CHGUI_Canvas.W = CHGUI_Width
		CHGUI_Canvas.H = CHGUI_Height
	End If
	
	'Move CHGUI
	If CHGUI_Moving = 1
		CHGUI_OffsetY = CHGUI_OffsetY - ((CHGUI_OffsetY-CHGUI_TargetY)/8)
		CHGUI_OffsetX = CHGUI_OffsetX - ((CHGUI_OffsetX-CHGUI_TargetX)/8)
		If CHGUI_OffsetY-CHGUI_TargetY >-1 And CHGUI_OffsetY-CHGUI_TargetY<1 And CHGUI_OffsetX-CHGUI_TargetX >-1 And CHGUI_OffsetX-CHGUI_TargetX<1 Then
			CHGUI_OffsetY = CHGUI_TargetY
			CHGUI_OffsetX = CHGUI_TargetX
			CHGUI_Moving = 0
		End If
	End If
	' Loop through All Windows
	For Local N = CHGUI_TopList.Length-1 to 0 Step -1
		CHGUI_UpdateContents(CHGUI_TopList[N])	
	Next 
	For Local N = CHGUI_VariList.Length-1 to 0 Step -1
		CHGUI_UpdateContents(CHGUI_VariList[N])	
	Next 
	For Local N = CHGUI_BottomList.Length-1 to 0 Step -1
		CHGUI_UpdateContents(CHGUI_BottomList[N])	
	Next 
	
	'Reset Flags 2
	
	If TouchDown() And CHGUI_DownFlag = 0 Then
		CHGUI_IgnoreMouse = 1
	Else
		CHGUI_IgnoreMouse = 0
	End If
	CHGUI_MenuClose = 0
	If CHGUI_MenuOver = 0 And TouchDown() Then CHGUI_MenuClose=1
	If CHGUI_CursorMillisecs < Millisecs() Then
		CHGUI_CursorMillisecs = Millisecs() + 300
		If CHGUI_Cursor = 0 Then
			CHGUI_Cursor = 1
		Else
			CHGUI_Cursor = 0
		End If
	End If
	'Drag Scroll
	If CHGUI_DragScroll = 1 Then 		
		If CHGUI_DragOver=0 And TouchDown() And CHGUI_DragMoving = 0 And CHGUI_TextboxOnFocus = 0 Then
			CHGUI_OffsetMX = TouchX()
			CHGUI_OffsetMY = TouchY()
			CHGUI_DragMoving = 1
		End If
		
		If CHGUI_DragMoving = 1 Then
			CHGUI_OffsetX = CHGUI_OffsetX + (TouchX() - CHGUI_OffsetMX)
			CHGUI_OffsetY = CHGUI_OffsetY + (TouchY() - CHGUI_OffsetMY)
			CHGUI_OffsetMX = TouchX()
			CHGUI_OffsetMY = TouchY()
			
			
			If CHGUI_OffsetX < -1*(CHGUI_Width - DeviceWidth())  Then CHGUI_OffsetX =  -1*(CHGUI_Width - DeviceWidth())
			If CHGUI_OffsetX > 0 Then CHGUI_OffsetX = 0
			
			If CHGUI_OffsetY <  DeviceHeight() - CHGUI_Height Then CHGUI_OffsetY = DeviceHeight() - CHGUI_Height 
			If CHGUI_OffsetY > 0 Then CHGUI_OffsetY = 0
		End If
		
		If CHGUI_Width < DeviceWidth() Then CHGUI_OffsetX = DeviceWidth()/2 - CHGUI_Width/2
		If CHGUI_Height < DeviceHeight() Then CHGUI_OffsetY = DeviceHeight()/2 - CHGUI_Height/2

				
		If TouchDown() = 0 Then CHGUI_DragMoving = 0
	End If
	'Revert after textbox off focus
	If TouchDown() And CHGUI_TextBoxDown = 0 And CHGUI_DragMoving=0 Then
		If CHGUI_Keyboard = 2 Then
			If TouchY() < DeviceHeight() - CHGUI_KeyboardWindow.H Then
				CHGUI_TargetX = CHGUI_OldX
				CHGUI_TargetY = CHGUI_OldY
				CHGUI_Moving = 1	
			End If
		Else
			CHGUI_TargetX = CHGUI_OldX
			CHGUI_TargetY = CHGUI_OldY
			CHGUI_Moving = 1
		End If
	End If	
	'Get Std Offset before onfocus
	If  CHGUI_TextBoxOver = 0 And CHGUI_TextboxOnFocus = 0 And CHGUI_Moving = 0 And CHGUI_DragMoving=0 Then
		CHGUI_OldX = CHGUI_OffsetX
		CHGUI_OldY = CHGUI_OffsetY
	End If
	
	CHGUI_UpdateMsgBox()
	
End Function

'summary: Place in OnRender() method to Draw the gui system
Function CHGUI_Draw()
	Local N
	Local NN
	
	SetBlend AlphaBlend
	SetColor(255,255,255)
	
	For  N = 0 to CHGUI_BottomList.Length-1
		If CHGUI_BottomList[N].Visible Then CHGUI_DrawContents(CHGUI_BottomList[N])
	Next
	For  N = 0 to CHGUI_VariList.Length-1
		If CHGUI_VariList[N].Visible Then CHGUI_DrawContents(CHGUI_VariList[N])
	Next
	For  N = 0 to CHGUI_TopList.Length-1
		If CHGUI_TopList[N].Visible Then CHGUI_DrawContents(CHGUI_TopList[N])
	Next
	
	If CHGUI_TooltipFlag <> Null Then CHGUI_DrawTooltip(CHGUI_TooltipFlag)
	
	CHGUI_FPSUpdate()
End Function

'summary: Locks focus on a window - and its subwindows/tabs (making all others inactive)
Function LockFocus(Window:CHGUI)
	If CHGUI_MsgBoxWindow.Visible = 0 Or Window = CHGUI_MsgBoxWindow
		CHGUI_LockedWIndow = Window
		CHGUI_Reorder(Window)
		CHGUI_Canvas.Active = 0
	End If
End Function

'summary: Returns the gui to its origional state after LockFocus() is used
Function UnlockFocus()
	If CHGUI_MsgBoxWindow.Visible = 0 Then
		CHGUI_LockedWIndow = Null
		CHGUI_Canvas.Active = 1
	End If
	
End Function

'summary: Display a Messgae box with an optional title & titlebar
Function MsgBox(Text:String, Title:String = "")
	CHGUI_MsgBoxWindow.Visible = 1
	CHGUI_MsgBoxLabel.Text = Text
	CHGUI_MsgBoxWindow.Text = Title
	'Position and sizes
	Local TL = CHGUI_Font.GetTxtWidth(Text)
	
	
	
	
	If TL > 150 Then 
		CHGUI_MsgBoxWindow.W = TL + 30	
	Else
		CHGUI_MsgBoxWindow.W = 180
	End If
	
	CHGUI_MsgBoxLabel.X=15
	
	If CHGUI_MsgBoxWindow.Text = "" Then
		CHGUI_MsgBoxLabel.Y=15
		CHGUI_MsgBoxWindow.H = 15 + CHGUI_TextHeight(CHGUI_Font,CHGUI_MsgBoxLabel.Text)+20+30+15
	Else
		CHGUI_MsgBoxLabel.Y=CHGUI_TitleHeight + 15
		CHGUI_MsgBoxWindow.H = 15 + CHGUI_TextHeight(CHGUI_Font,CHGUI_MsgBoxLabel.Text)+20+30+15+CHGUI_TitleHeight
	End If
	
	CHGUI_MsgBoxButton.W = 100
	CHGUI_MsgBoxButton.X = (CHGUI_MsgBoxWindow.W/2)-50
	CHGUI_MsgBoxButton.Y = CHGUI_MsgBoxLabel.Y + CHGUI_TextHeight(CHGUI_Font,CHGUI_MsgBoxLabel.Text)+20
	
	LockFocus(CHGUI_MsgBoxWindow)
End Function

'summary: Limit the input accepted by a Textfield
Function FormatTextfield(Textfield:CHGUI,Text=1, Numbers=1, Symbols=1, Spaces=1)
	Textfield.FormatNumber = Numbers
	Textfield.FormatSpace = Spaces
	Textfield.FormatSymbol = Symbols
	Textfield.FormatText = Text
End Function

'summary: Remove a created CHGUI element
Function CHGUI_Delete(N:CHGUI)
	Local C
	
	'Top WIndow
	If N.Element = "Window" And N.Mode =2 Then
		For C = 0 to N.Parent.TopList.Length-1
			If N.Parent.TopList[C] = N Then Exit
		Next
			
		For Local NN = C to N.Parent.TopList.Length-2
			N.Parent.TopList[NN] = N.Parent.TopList[NN+1]
		Next
		N.Parent.TopList = N.Parent.TopList[..N.Parent.TopList.Length-1]
		
	'Vari WIndow
	ElseIf N.Element = "Window" And N.Mode =1 Then
		For C = 0 to N.Parent.VariList.Length-1
			If N.Parent.VariList[C] = N Then Exit
		Next
			
		For Local NN = C to N.Parent.VariList.Length-2
			N.Parent.VariList[NN] = N.Parent.VariList[NN+1]
		Next
		N.Parent.VariList = N.Parent.VariList[..N.Parent.VariList.Length-1]	
		
	'Bottom WIndow
	ElseIf N.Element = "Window" And N.Mode =0 Then
		For C = 0 to N.Parent.BottomList.Length-1
			If N.Parent.BottomList[C] = N Then Exit
		Next
			
		For Local NN = C to N.Parent.BottomList.Length-2
			N.Parent.BottomList[NN] = N.Parent.BottomList[NN+1]
		Next
		N.Parent.BottomList = N.Parent.BottomList[..N.Parent.BottomList.Length-1]	
		
	'Menus
	ElseIf N.Element = "Menu" Then
		For C = 0 to N.Parent.Menus.Length-1
			If N.Parent.Menus[C] = N Then Exit
		Next
			
		For Local NN = C to N.Parent.Menus.Length-2
			N.Parent.Menus[NN] = N.Parent.Menus[NN+1]
		Next
		N.Parent.Menus = N.Parent.Menus[..N.Parent.Menus.Length-1]		
		
	'MenuItems
	ElseIf N.Element = "MenuItem" Then
		For C = 0 to N.Parent.MenuItems.Length-1
			If N.Parent.MenuItems[C] = N Then Exit
		Next
			
		For Local NN = C to N.Parent.MenuItems.Length-2
			N.Parent.MenuItems[NN] = N.Parent.MenuItems[NN+1]
		Next
		N.Parent.MenuItems = N.Parent.MenuItems[..N.Parent.MenuItems.Length-1]	
		
	'Tabs
	ElseIf N.Element = "Tab" Then
		For C = 0 to N.Parent.Tabs.Length-1
			If N.Parent.Tabs[C] = N Then Exit
		Next
			
		For Local NN = C to N.Parent.Tabs.Length-2
			N.Parent.Tabs[NN] = N.Parent.Tabs[NN+1]
		Next
		N.Parent.Tabs = N.Parent.Tabs[..N.Parent.Tabs.Length-1]		
		
	'Buttons
	ElseIf N.Element = "Button" Then
		For C = 0 to N.Parent.Buttons.Length-1
			If N.Parent.Buttons[C] = N Then Exit
		Next
			
		For Local NN = C to N.Parent.Buttons.Length-2
			N.Parent.Buttons[NN] = N.Parent.Buttons[NN+1]
		Next
		N.Parent.Buttons = N.Parent.Buttons[..N.Parent.Buttons.Length-1]		
		
	'ImageButtons
	ElseIf N.Element = "ImageButton" Then
		For C = 0 to N.Parent.ImageButtons.Length-1
			If N.Parent.ImageButtons[C] = N Then Exit
		Next
			
		For Local NN = C to N.Parent.ImageButtons.Length-2
			N.Parent.ImageButtons[NN] = N.Parent.ImageButtons[NN+1]
		Next
		N.Parent.ImageButtons = N.Parent.ImageButtons[..N.Parent.ImageButtons.Length-1]	
		
	'Tickboxes
	ElseIf N.Element = "Tickbox" Then
		For C = 0 to N.Parent.Tickboxes.Length-1
			If N.Parent.Tickboxes[C] = N Then Exit
		Next
			
		For Local NN = C to N.Parent.Tickboxes.Length-2
			N.Parent.Tickboxes[NN] = N.Parent.Tickboxes[NN+1]
		Next
		N.Parent.Tickboxes = N.Parent.Tickboxes[..N.Parent.Tickboxes.Length-1]		
		
	'Radioboxes
	ElseIf N.Element = "Radio" Then
		For C = 0 to N.Parent.Radioboxes.Length-1
			If N.Parent.Radioboxes[C] = N Then Exit
		Next
			
		For Local NN = C to N.Parent.Radioboxes.Length-2
			N.Parent.Radioboxes[NN] = N.Parent.Radioboxes[NN+1]
		Next
		N.Parent.Radioboxes = N.Parent.Radioboxes[..N.Parent.Radioboxes.Length-1]	
		
	'Listboxes
	ElseIf N.Element = "Listbox" Then
		For C = 0 to N.Parent.Listboxes.Length-1
			If N.Parent.Listboxes[C] = N Then Exit
		Next
			
		For Local NN = C to N.Parent.Listboxes.Length-2
			N.Parent.Listboxes[NN] = N.Parent.Listboxes[NN+1]
		Next
		N.Parent.Listboxes = N.Parent.Listboxes[..N.Parent.Listboxes.Length-1]		
		
	'ListboxItems
	ElseIf N.Element = "ListboxItem" Then
		For C = 0 to N.Parent.ListboxItems.Length-1
			If N.Parent.ListboxItems[C] = N Then Exit
		Next
			
		For Local NN = C to N.Parent.ListboxItems.Length-2
			N.Parent.ListboxItems[NN] = N.Parent.ListboxItems[NN+1]
		Next
		N.Parent.ListboxItems = N.Parent.ListboxItems[..N.Parent.ListboxItems.Length-1]	
		
	'Dropdowns
	ElseIf N.Element = "Dropdown" Then
		For C = 0 to N.Parent.Dropdowns.Length-1
			If N.Parent.Dropdowns[C] = N Then Exit
		Next
			
		For Local NN = C to N.Parent.Dropdowns.Length-2
			N.Parent.Dropdowns[NN] = N.Parent.Dropdowns[NN+1]
		Next
		N.Parent.Dropdowns = N.Parent.Dropdowns[..N.Parent.Dropdowns.Length-1]	
		
	'DropdownItems
	ElseIf N.Element = "DropdownItem" Then
		For C = 0 to N.Parent.DropdownItems.Length-1
			If N.Parent.DropdownItems[C] = N Then Exit
		Next
			
		For Local NN = C to N.Parent.DropdownItems.Length-2
			N.Parent.DropdownItems[NN] = N.Parent.DropdownItems[NN+1]
		Next
		N.Parent.DropdownItems = N.Parent.DropdownItems[..N.Parent.DropdownItems.Length-1]	
		
	'Textfields
	ElseIf N.Element = "Textfield" Then
		For C = 0 to N.Parent.Textfields.Length-1
			If N.Parent.Textfields[C] = N Then Exit
		Next
			
		For Local NN = C to N.Parent.Textfields.Length-2
			N.Parent.Textfields[NN] = N.Parent.Textfields[NN+1]
		Next
		N.Parent.Textfields = N.Parent.Textfields[..N.Parent.Textfields.Length-1]			
		
	'Labels
	ElseIf N.Element = "Label" Then
		For C = 0 to N.Parent.Labels.Length-1
			If N.Parent.Labels[C] = N Then Exit
		Next
			
		For Local NN = C to N.Parent.Labels.Length-2
			N.Parent.Labels[NN] = N.Parent.Labels[NN+1]
		Next
		N.Parent.Labels = N.Parent.Labels[..N.Parent.Labels.Length-1]	
		
	'VSliders
	ElseIf N.Element = "VSlider" Then
		For C = 0 to N.Parent.VSliders.Length-1
			If N.Parent.VSliders[C] = N Then Exit
		Next
			
		For Local NN = C to N.Parent.VSliders.Length-2
			N.Parent.VSliders[NN] = N.Parent.VSliders[NN+1]
		Next
		N.Parent.VSliders = N.Parent.VSliders[..N.Parent.VSliders.Length-1]		
		
	'HSliders
	ElseIf N.Element = "HSlider" Then
		For C = 0 to N.Parent.HSliders.Length-1
			If N.Parent.HSliders[C] = N Then Exit
		Next
			
		For Local NN = C to N.Parent.HSliders.Length-2
			N.Parent.HSliders[NN] = N.Parent.HSliders[NN+1]
		Next
		N.Parent.HSliders = N.Parent.HSliders[..N.Parent.HSliders.Length-1]		
		
		
		
	End If
	
	
	
	
	

		
	
End Function

Private

'#Region UPDATE FUNCTIONS
Function CHGUI_UpdateContents(N:CHGUI)
	Local X
	Local XX
	Local C
	N.ReOrdered = 0
	'Update MenuItems
	For X = N.Menus.Length-1 to 0 Step -1
		N.Menus[X].CheckClicked()
		CHGUI_UpdateSubMenu(N.Menus[X])
	Next
	
	If N.Tabbed Then
		CHGUI_UpdateContents(N.CurrentTab)
	End If
	
	'Update The SubWindows
	For Local NN = N.TopList.Length-1 to 0 Step -1
			CHGUI_UpdateContents(N.TopList[NN])
	Next
	
	For Local NN = N.VariList.Length-1 to 0 Step -1
		CHGUI_UpdateContents(N.VariList[NN])
	Next
	
	For Local NN = N.BottomList.Length-1 to 0 Step -1
		CHGUI_UpdateContents(N.BottomList[NN])
	Next

	'Update Tabs
	For X = N.Tabs.Length-1 to 0 Step -1
		N.Tabs[X].CheckClicked()
		If CHGUI_RealActive(N.Tabs[X]) And CHGUI_RealVisible(N.Tabs[X]) And CHGUI_RealMinimised(N.Tabs[X])=0 Then CHGUI_UpdateTab(N.Tabs[X])
	Next
	
	
	'Update Menus
	If CHGUI_MenuClose Then N.MenuActive = Null
	For X = N.Menus.Length-1 to 0 Step -1
		N.Menus[X].CheckClicked()
		If CHGUI_RealVisible(N.Menus[X]) And CHGUI_RealMinimised(N.Menus[X])=0 And CHGUI_RealActive(N.Menus[X]) Then CHGUI_UpdateMenu(N.Menus[X])
	Next
	
	'Update DropdownItems
	For X = N.Dropdowns.Length-1 to 0 Step -1
			C = 0
			For XX = 0 To N.Dropdowns[X].DropdownItems.Length-1
				N.Dropdowns[X].DropdownItems[XX].CheckClicked()
				If CHGUI_RealVisible(N.Dropdowns[X].DropdownItems[XX]) And N.Dropdowns[X].OnFocus And CHGUI_RealVisible(N.Dropdowns[X]) Then CHGUI_UpdateDropdownItem(N.Dropdowns[X].DropdownItems[XX],C)
				If CHGUI_RealVisible(N.Dropdowns[X].DropdownItems[XX]) And N.Dropdowns[X].OnFocus And CHGUI_RealVisible(N.Dropdowns[X]) Then C = C + 1
			Next
	Next
	
	'Update Dropdowns
	For X = N.Dropdowns.Length-1 to 0 Step -1
		N.Dropdowns[X].CheckClicked()
		If CHGUI_RealActive(N.Dropdowns[X]) And CHGUI_RealVisible(N.Dropdowns[X]) And CHGUI_RealMinimised(N.Dropdowns[X])=0 Then CHGUI_UpdateDropdown(N.Dropdowns[X])
	Next
	
	'Update Labels
	For X = N.Labels.Length-1 to 0 Step -1
		N.Labels[X].CheckClicked()
		If CHGUI_RealVisible(N.Labels[X]) And CHGUI_RealMinimised(N.Labels[X])=0 And CHGUI_RealActive(N.Labels[X]) Then CHGUI_UpdateLabel(N.Labels[X])
	Next
	
	'Update Textfields
	For X = N.Textfields.Length-1 to 0 Step -1
		N.Textfields[X].CheckClicked()
		If CHGUI_RealVisible(N.Textfields[X]) And CHGUI_RealMinimised(N.Textfields[X])=0 And CHGUI_RealActive(N.Textfields[X]) Then CHGUI_UpdateTextfield(N.Textfields[X])
	Next
	
	'Update HSliders
	For X = N.HSliders.Length-1 to 0 Step -1
		N.HSliders[X].CheckClicked()
		If CHGUI_RealVisible(N.HSliders[X]) And CHGUI_RealMinimised(N.HSliders[X])=0 And CHGUI_RealActive(N.HSliders[X]) Then CHGUI_UpdateHSlider(N.HSliders[X])
	Next
	
	'Update VSliders
	For X = N.VSliders.Length-1 to 0 Step -1
		N.VSliders[X].CheckClicked()
		If CHGUI_RealVisible(N.VSliders[X]) And CHGUI_RealMinimised(N.VSliders[X])=0 And CHGUI_RealActive(N.VSliders[X]) Then CHGUI_UpdateVSlider(N.VSliders[X])
	Next
	
	'Update ListBoxes
	For X = N.Listboxes.Length-1 to 0 Step -1
		N.Listboxes[X].CheckClicked()
		If CHGUI_RealVisible(N.Listboxes[X]) And CHGUI_RealMinimised(N.Listboxes[X])=0 And CHGUI_RealActive(N.Listboxes[X]) Then
			Local C = 0
			'Update Listbox Items
			For XX = Int(N.Listboxes[X].ListboxSlider.Value) to N.Listboxes[X].ListboxSlider.Value + N.Listboxes[X].ListboxNumber
				If XX < N.Listboxes[X].ListboxItems.Length And XX > -1 Then
					If CHGUI_RealVisible(N.Listboxes[X].ListboxItems[XX]) And CHGUI_RealMinimised(N.Listboxes[X].ListboxItems[XX])=0 And CHGUI_RealActive(N.Listboxes[X].ListboxItems[XX]) Then
						N.Listboxes[X].ListboxItems[XX].CheckClicked()
						CHGUI_UpdateListboxItem(N.Listboxes[X].ListboxItems[XX],C)
						C = C +1
					End If
				End If
			Next
			CHGUI_UpdateListbox(N.Listboxes[X])
		End If
	Next
		
	'Update Radioboxes
	For X = N.Radioboxes.Length-1 to 0 Step -1
		N.Radioboxes[X].CheckClicked()
		If CHGUI_RealVisible(N.Radioboxes[X]) And CHGUI_RealMinimised(N.Radioboxes[X])=0 And CHGUI_RealActive(N.Radioboxes[X]) Then CHGUI_UpdateRadiobox(N.Radioboxes[X])
	Next
	
	'Update Tickboxes
	For X = N.Tickboxes.Length-1 to 0 Step -1
		N.Tickboxes[X].CheckClicked()
		If CHGUI_RealVisible(N.Tickboxes[X]) And CHGUI_RealActive(N.Tickboxes[X]) And CHGUI_RealMinimised(N.Tickboxes[X])=0 Then CHGUI_UpdateTickbox(N.Tickboxes[X])
	Next
	
	'Image Buttons
	For X = N.ImageButtons.Length-1 to 0 Step -1
		N.ImageButtons[X].CheckClicked()
		If CHGUI_RealVisible(N.ImageButtons[X]) And CHGUI_RealMinimised(N.ImageButtons[X])=0  And CHGUI_RealActive(N.ImageButtons[X])Then CHGUI_UpdateImageButton(N.ImageButtons[X])
	Next
	
	'Update Buttons
	For X = N.Buttons.Length-1 to 0 Step -1
		N.Buttons[X].CheckClicked()
		If CHGUI_RealVisible(N.Buttons[X]) And CHGUI_RealMinimised(N.Buttons[X])=0  And CHGUI_RealActive(N.Buttons[X]) Then CHGUI_UpdateButton(N.Buttons[X])
	Next
	
	If N.Element <> "Tab" Then
		'Update window
		N.CheckClicked()
		If CHGUI_RealVisible(N) And CHGUI_RealActive(N) Or CHGUI_Locked(N) Then CHGUI_UpdateWindow(N)
	End If

End Function

Function CHGUI_UpdateWindow(N:CHGUI)
	Local X:Float = CHGUI_RealX(N)
	Local Y:Float = CHGUI_RealY(N)
	Local W = N.W
	Local H = N.H 
	
	If N.Minimised Then H = CHGUI_TitleHeight
	Local TH = CHGUI_TitleHeight
	
	If N.Text = "" Then
		N.Close = 0
		N.Minimise = 0
	End If
	
	N.CheckOver()
	N.CheckDown()
	
	'Drag Check
	If N.Over Then
		If TouchY() > Y And TouchY()<Y+CHGUI_TitleHeight Then
			CHGUI_DragOver = 1
		End If
	End If
	
	
	
	'Close Button Checks
	If N.Close Then
		Local TH:Float = CHGUI_TitleHeight
		If N.CloseOver And N.CloseDown And TouchDown() = 0 Then
			N.CloseOver = 0
			N.CloseDown = 0
			N.Visible = 0
		End If
		If N.Over And TouchX() > X+W-(TH/2.5)-10 And TouchX() < X+W-(TH/2.5)-10 + TH/2.5 And TouchY() > Y+(TH-TH/2.5)/2 And TouchY() < Y+(TH-TH/2.5)/2 + TH/2.5 Then
			If CHGUI_MouseBusy = 0 Or N.CloseDown Then
				N.CloseOver = 1
				CHGUI_DragOver = 1
			End If
		Else
			N.CloseOver = 0
		End If
		If N.CloseOver Or N.CloseDown
			If TouchDown() Then
				N.CloseDown = 1
				CHGUI_DragOver = 1
			Else
				N.CloseDown = 0
			End If
		Else
			N.CloseDown = 0
		End If
	End If
	
	'Minimise Button Checks
	If N.Minimise Then 
		Local TH1:Float = CHGUI_TitleHeight
		Local Off2 = (TH1 -(TH1/2))/2
	
		If N.MinimiseOver And N.MinimiseDown And TouchDown() = 0 Then
			N.CloseOver = 0
			N.CloseDown = 0
			If N.Minimised = 0 Then
				N.Minimised = 1
			Else
				N.Minimised = 0
			End If
		End If
		
		If N.Over And TouchX() > X+W-(TH/2.5 + TH/2.5)-TH/1.5 And TouchX() < X+W-(TH/2.5 + TH/2.5)-TH/1.5 + TH/2.5 And TouchY() > Y+(TH-TH/2.5)/2 And TouchY() < Y+(TH-TH/2.5)/2 + TH/2.5 Then
			If CHGUI_MouseBusy = 0 Or N.MinimiseDown Then
				N.MinimiseOver = 1
				CHGUI_DragOver = 1
			End If
		Else
			N.MinimiseOver = 0
		End If
		If N.MinimiseOver Or N.MinimiseDown
			If TouchDown() Then
				N.MinimiseDown = 1
				CHGUI_DragOver = 1
			Else
				N.MinimiseDown = 0
			End If
		Else
			N.MinimiseDown = 0
		End If
	End If	
	
		'Moving
	If N.Moveable = 1 And N.Over And N.Moving = 0Then
		If TouchY() > Y And TouchY()<Y+CHGUI_TitleHeight And TouchDown() And N.Text <> "" Then
			If N.CloseOver = 0 And N.MinimiseOver = 0 And N.CloseDown = 0 And N.MinimiseDown = 0 Then
				If CHGUI_Moving=0
					N.Moving = 1
					N.MX = TouchX()
					N.MY = TouchY()
				End If
			End If
		End If
	End If
	If TouchDown() = 0 Then N.Moving = 0
	
	If N.Moving = 1
		N.X = N.X + (TouchX() - N.MX)
		N.Y = N.Y + (TouchY() - N.MY)
		N.MX = TouchX()
		N.MY = TouchY()
		CHGUI_DragOver = 1
		'Get The Real Parent (Not Tabs)
		Local RP:CHGUI = N.Parent
		
		Repeat
			If RP.Element <> "Tab" Then Exit
			If RP.Parent <> Null Then 
				RP = RP.Parent
			Else
				Exit	
			End If
		Forever
		

		If N.X < 0 Then N.X = 0

		If N.X > (RP.W-N.W) Then N.X = (RP.W-N.W)

		If N.Y>RP.H-H Then N.Y = RP.H-H

		Local YVal = RP.MenuHeight
		If RP.Text <> "" Then YVal = YVal + CHGUI_TitleHeight
		If RP.Tabbed Then YVal = YVal + RP.TabHeight+5
	
		If N.Y < YVal Then N.Y = YVal
	End If
	
		
		'Double Click
	If N.Clicked And TouchY() > Y And TouchY()<Y+CHGUI_TitleHeight  And N.Text <> "" Then
		If N.Minimise And N.CloseOver=0 And N.MinimiseOver=0 Then
			If N.DClickMillisecs > Millisecs() Then
				If N.Minimised = 1 Then
					N.Minimised = 0
				Else
					N.Minimised = 1
				End If
			Else
				N.DClickMillisecs = Millisecs() + 275
			End If
		End If
	End If
	
	
End Function

Function CHGUI_UpdateButton(N:CHGUI)
	N.CheckOver()
	N.CheckDown()
	'Tooltip Flag
	If CHGUI_Tooltips = 1 And N.Tooltip <> "" And N.OverTime > CHGUI_TooltipTime Then
		If TouchDown() = 0 CHGUI_TooltipFlag = N
	End If	
End Function

Function CHGUI_UpdateImageButton(N:CHGUI)
	N.W = N.Img.Width()/4
	N.H = N.Img.Height()
	N.CheckOver()
	N.CheckDown()
	'Tooltip Flag
	If CHGUI_Tooltips = 1 And N.Tooltip <> "" And N.OverTime > CHGUI_TooltipTime Then
		If TouchDown() = 0 CHGUI_TooltipFlag = N
	End If	
End Function

Function CHGUI_UpdateTickbox(N:CHGUI)
	N.CheckOver()
	N.CheckDown()
	N.W = N.H + (N.H/4) + CHGUI_Font.GetTxtWidth(N.Text)
	If N.Clicked Then
		If N.Value = 0 Then
			N.Value = 1
		Else
			N.Value = 0
		End If
	End If
	
	'Tooltip Flag
	If CHGUI_Tooltips = 1 And N.Tooltip <> "" And N.OverTime > CHGUI_TooltipTime Then
		If TouchDown() = 0 CHGUI_TooltipFlag = N
	End If
	
End Function

Function CHGUI_UpdateRadiobox(N:CHGUI)
	N.CheckOver()
	N.CheckDown()
	N.W = N.H + (N.H/4) + CHGUI_Font.GetTxtWidth(N.Text)
	If N.Clicked Then
			N.Value = 1
			For Local X = 0 to N.Parent.Radioboxes.Length-1
				If N.Parent.Radioboxes[X].Group = N.Group And N.Parent.Radioboxes[X] <> N Then
					N.Parent.Radioboxes[X].Value=0
				End If
			Next
	End If
	'Tooltip Flag
	If CHGUI_Tooltips = 1 And N.Tooltip <> "" And N.OverTime > CHGUI_TooltipTime Then
		If TouchDown() = 0 CHGUI_TooltipFlag = N
	End If
End Function

Function CHGUI_UpdateDropdown(N:CHGUI)
	N.CheckOver()
	N.CheckDown()	
	
	If N.Clicked Then
		If N.OnFocus = 1 Then
			N.OnFocus = 0
		Else
			N.OnFocus = 1
		End If
	End If
	'Tooltip Flag
	If CHGUI_Tooltips = 1 And N.Tooltip <> "" And N.OverTime > CHGUI_TooltipTime Then
		If TouchDown() = 0 CHGUI_TooltipFlag = N
	End If
End Function

Function CHGUI_UpdateDropdownItem(N:CHGUI,C)
	N.H = N.Parent.H
	N.W = N.Parent.W
	N.X = 0
	N.Y = N.Parent.H + (C*N.H)-C-1

	N.CheckOver()
	N.CheckDown()
	
	If N.Clicked Then
		N.Parent.Text = N.Text
		N.Parent.Value = N.Value
		N.Parent.OnFocus = 0
	End If      
	
	If TouchDown() 
		If TouchX() < CHGUI_RealX(N.Parent) Or TouchX() > CHGUI_RealX(N.Parent)+ N.W Or TouchY() < CHGUI_RealY(N.Parent) Or TouchY() > CHGUI_RealY(N.Parent)+ N.H*(N.Parent.DropdownItems.Length+1) Then
			N.Parent.OnFocus = 0
			N.Parent.Over = 0
			N.Parent.Down = 0
		End If
	End If
'Tooltip Flag
	If CHGUI_Tooltips = 1 And N.Tooltip <> "" And N.OverTime > CHGUI_TooltipTime Then
		If TouchDown() = 0 CHGUI_TooltipFlag = N
	End If
End Function

Function CHGUI_UpdateMenu(N:CHGUI)
	N.CheckOver()
	N.CheckDown()
	If N.Over Then CHGUI_MenuOver=1
	
	If N.Clicked Then 
		If N.Parent.MenuActive <> N
			If N.MenuItems.Length > 0 Then 
				N.OnFocus = 1
				N.Parent.MenuActive = N
			End If
		Else
			N.OnFocus = 0
			CHGUI_CloseMenuReverse(N.Parent.MenuActive)
			N.Parent.MenuActive = Null
		End If
	End If
	
	
	If N.OnFocus And N.MenuItems.Length < 1 Then N.OnFocus = 0
	If N.Over And N.Parent.MenuActive <> Null Then
		N.Parent.MenuActive.OnFocus = 0
		CHGUI_CloseMenuReverse(N.Parent.MenuActive)
		N.Parent.MenuActive = N
		N.OnFocus = 1
	End If
	'Tooltip Flag
	If CHGUI_Tooltips = 1 And N.Tooltip <> "" And N.OverTime > CHGUI_TooltipTime Then
		If TouchDown() = 0 CHGUI_TooltipFlag = N
	End If
End Function

Function CHGUI_UpdateMenuItem(N:CHGUI)	
	N.CheckOver()
	If CHGUI_RealActive(N) Then N.CheckDown()
	If CHGUI_RealVisible(N)=0 then CHGUI_CloseMenu(N)
	
	If N.Over Then CHGUI_MenuOver=1
	
	If N.IsMenuParent And N.Over And CHGUI_RealActive(N) Then
		N.OnFocus = 1
		If N.Parent.MenuOver <> Null And N <> N.Parent.MenuOver Then
			N.Parent.MenuOver.OnFocus = 0
			CHGUI_CloseMenuReverse(N.Parent.MenuOver)
		End If
		N.Parent.MenuOver= N
	End If
	
	If N.Parent.MenuOver <> Null And N.Over And N <> N.Parent.MenuOver Then N.Parent.MenuOver.OnFocus = 0

	If N.Clicked Then 
		If N.IsMenuParent=0 And N.Tick = 0 Then	
			CHGUI_CloseMenu(N)
		End If
		If N.Tick Then
			If N.Value = 0 Then
				N.Value = 1
			Else
				N.Value = 0
			End If
		End If
	End If
	'Tooltip Flag
	If CHGUI_Tooltips = 1 And N.Tooltip <> "" And N.OverTime > CHGUI_TooltipTime Then
		If TouchDown() = 0 CHGUI_TooltipFlag = N
	End If
	If CHGUI_MenuClose Then CHGUI_CloseMenu(N)
End Function

Function CHGUI_UpdateSubMenu(N:CHGUI)
	Local XX
	For XX = N.MenuItems.Length-1 to 0 Step -1
		N.MenuItems[XX].CheckClicked()
		If CHGUI_RealVisible(N.MenuItems[XX]) And CHGUI_RealMinimised(N.MenuItems[XX])=0 And N.OnFocus Then CHGUI_UpdateMenuItem(N.MenuItems[XX])
	Next
	For XX = N.MenuItems.Length-1 to 0 Step -1
		If  N.MenuItems[XX].IsMenuParent Then CHGUI_UpdateSubMenu(N.MenuItems[XX])
	Next
End Function

Function CHGUI_CloseMenu(N:CHGUI)
	N.OnFocus=0
	Local E:CHGUI = N
	Repeat
		If E.Parent.Element = "Window" Then E.Parent.MenuActive = Null ; Exit
		If E.Parent.Element = "MenuItem" Then E.Parent.OnFocus = 0
		If E.Parent.Element = "Menu" Then E.Parent.OnFocus = 0 
	'	If E.Parent.Element <> "Menu" And E.Parent.Element <> "MenuItem" Then Exit
		E = E.Parent
	Forever
End Function

Function CHGUI_CloseMenuReverse(N:CHGUI)
	N.OnFocus=0
	Local E:CHGUI = N
	Local C 
	For C = 0 to E.MenuItems.Length-1
		If E.MenuItems.Length > 0 Then	
			CHGUI_CloseMenuReverse(E.MenuItems[C])
			E.MenuItems[C].OnFocus = 0
		Else
			Exit
		End If
	Next
End Function

Function CHGUI_UpdateHSlider(N:CHGUI)
	N.CheckOver()
	N.CheckDown()
	If N.Value < N.Minimum Then N.Value = N.Minimum
	If N.Value > N.Maximum Then N.Value = N.Maximum
	Local X = CHGUI_RealX(N)
	Local Y = CHGUI_RealY(N)
	Local W =N.W
	Local H = N.H 
	
	'Slider stuff
	N.Stp =   (N.W-(2*N.H)) / (N.Maximum - N.Minimum)
	N.SWidth = N.Stp
	If N.SWidth < N.H Then N.SWidth = N.H
	If N.SWidth > (N.W-N.H-N.H-10) Then N.SWidth = (N.W-N.H-N.H-10)
	N.Stp = (N.W-N.SWidth-N.H-N.H) / (N.Maximum - N.Minimum)
	N.SWidth = N.SWidth + 10
	
	'Minus Button Clicked
	If N.MinusOver And N.MinusDown And TouchDown() = 0 Then
		N.MinusOver = 0
		N.MinusDown = 0
		N.Value = N.Value-1
		If N.Value < N.Minimum Then N.Value = N.Minimum
	End If

	'Minus Button Over
	If N.Over And TouchX() > X And TouchX() < X+H And TouchY() > Y And TouchY() < Y+H Then
		If CHGUI_MouseBusy = 0 Or N.MinusDown Then
			N.MinusOver = 1
		End If
	Else
		N.MinusOver = 0
	End If
	
	'Minus Button Down
	If N.MinusOver Or N.MinusDown
		If TouchDown() Then
			N.MinusDown = 1
		Else
			N.MinusDown = 0
		End If
	Else
		N.MinusDown = 0
	End If
	
	'Plus Button Clicked
	If N.PlusOver And N.PlusDown And TouchDown() = 0 Then
		N.PlusOver = 0
		N.PlusDown = 0
		N.Value = N.Value+1
		If N.Value > N.Maximum Then N.Value = N.Maximum
	End If

	'Plus Over
	If TouchX() > X+W-H And TouchX() < X+W And TouchY() > Y And TouchY() < Y+H Then
			If CHGUI_MouseBusy = 0 Or N.PlusDown Then
				N.PlusOver = 1
			End If
		Else
			N.PlusOver = 0
		End If
		
	'Plus Down
	If N.PlusOver Or N.PlusDown
		If TouchDown() Then
			N.PlusDown = 1
		Else
			N.PlusDown = 0
		End If
	Else
		N.PlusDown = 0
	End If
	
	'Slider Over
	Local XPOS:Float = X+H-5 + ((N.Value -N.Minimum)* N.Stp)
	
	If N.Over And TouchX()>XPOS And TouchX<XPOS+N.SWidth And N.PlusOver=0 And N.MinusOver=0 Then
		If CHGUI_MouseBusy = 0 Or N.SliderDown Then
			N.SliderOver = 1
			If N.SliderDown=0 Then N.Start = TouchX()
		End If
	Else
		N.SliderOver = 0
	End If
	'Slider Down
	If N.SliderOver Or N.SliderDown
		If TouchDown() Then
			N.SliderDown = 1
		Else
			N.SliderDown = 0
		End If
	Else
		N.SliderDown = 0
	End If
	
	If N.SliderDown Then
		Local Change:Float = TouchX() - N.Start
		N.Value = N.Value + (Change/N.Stp)
		N.Start = TouchX()
		If N.Value < N.Minimum Then N.Value = N.Minimum
		If N.Value > N.Maximum Then N.Value = N.Maximum
	End If
	
	If N.SliderDown=0 And N.MinusDown=0 And N.PlusDown=0 And N.Down Then
		N.Value = ((TouchX()-X-H-H+10) / (N.Stp)) + N.Minimum
		If N.Value < N.Minimum Then N.Value = N.Minimum
		If N.Value > N.Maximum Then N.Value = N.Maximum
	End If
	'Tooltip Flag
	If CHGUI_Tooltips = 1 And N.Tooltip <> "" And N.OverTime > CHGUI_TooltipTime Then
		If TouchDown() = 0 CHGUI_TooltipFlag = N
	End If
	
End Function

Function CHGUI_UpdateVSlider(N:CHGUI)
	N.CheckOver()
	N.CheckDown()
	If N.Value < N.Minimum Then N.Value = N.Minimum
	If N.Value > N.Maximum Then N.Value = N.Maximum
	Local X = CHGUI_RealX(N)
	Local Y = CHGUI_RealY(N)
	Local W =N.W
	Local H = N.H 
	
	'Slider stuff
	N.Stp =   (N.H-(2*N.W)) / (N.Maximum - N.Minimum)
	N.SWidth = N.Stp
	If N.SWidth < N.W Then N.SWidth = N.W
	If N.SWidth > (N.H-N.W-N.W-10) Then N.SWidth = (N.H-N.W-N.W-10)
	N.Stp = (N.H-N.SWidth-N.W-N.W) / (N.Maximum - N.Minimum)
	N.SWidth = N.SWidth + 10
	
		
	'Minus Button Clicked
	If N.MinusOver And N.MinusDown And TouchDown() = 0 Then
		N.MinusOver = 0
		N.MinusDown = 0
		N.Value = N.Value-1
		If N.Value < N.Minimum Then N.Value = N.Minimum
	End If

	'Minus Over
	If TouchX() > X And TouchX() < X+W And TouchY() > Y And TouchY() < Y+W Then
			If CHGUI_MouseBusy = 0 Or N.MinusDown Then
				N.MinusOver = 1
			End If
		Else
			N.MinusOver = 0
		End If
		
	'Minus Down
	If N.MinusOver Or N.MinusDown
		If TouchDown() Then
			N.MinusDown = 1
		Else
			N.MinusDown = 0
		End If
	Else
		N.MinusDown = 0
	End If
	
	'Plus Button Clicked
	If N.PlusOver And N.PlusDown And TouchDown() = 0 Then
		N.PlusOver = 0
		N.PlusDown = 0
		N.Value = N.Value+1
		If N.Value > N.Maximum Then N.Value = N.Maximum
	End If

	'Plus Button Over
	If N.Over And TouchX() > X And TouchX() < X+W And TouchY() > Y+H-W And TouchY() < Y+H Then
		If CHGUI_MouseBusy = 0 Or N.PlusDown Then
			N.PlusOver = 1
		End If
	Else
		N.PlusOver = 0
	End If
	
	'Plus Button Down
	If N.PlusOver Or N.PlusDown
		If TouchDown() Then
			N.PlusDown = 1
		Else
			N.PlusDown = 0
		End If
	Else
		N.PlusDown = 0
	End If
	
	'Slider Over
	Local YPOS:Float = Y+W-5 + ((N.Value-N.Minimum) * N.Stp)
	
	If N.Over And TouchY()>YPOS And TouchY<YPOS+N.SWidth  And N.PlusOver=0 And N.MinusOver=0 Then
		If CHGUI_MouseBusy = 0 Or N.SliderDown Then
			N.SliderOver = 1
			If N.SliderDown=0 Then N.Start = TouchY()
		End If
	Else
		N.SliderOver = 0
	End If
	'Slider Down
	If N.SliderOver Or N.SliderDown
		If TouchDown() Then
			N.SliderDown = 1
		Else
			N.SliderDown = 0
		End If
	Else
		N.SliderDown = 0
	End If
	
	If N.SliderDown Then
		Local Change:Float = TouchY() - N.Start
		N.Value = (N.Value) + (Change/N.Stp)
		N.Start = TouchY()
		If N.Value < N.Minimum Then N.Value = N.Minimum
		If N.Value > N.Maximum Then N.Value = N.Maximum
	End If
	
	If N.SliderDown=0 And N.MinusDown=0 And N.PlusDown=0 And N.Down Then
		N.Value = ((TouchY()-Y-W-W+10) / N.Stp)+N.Minimum
		If N.Value < N.Minimum Then N.Value = N.Minimum
		If N.Value > N.Maximum Then N.Value = N.Maximum
	End If
	'Tooltip Flag
	If CHGUI_Tooltips = 1 And N.Tooltip <> "" And N.OverTime > CHGUI_TooltipTime Then
		If TouchDown() = 0 CHGUI_TooltipFlag = N
	End If
	
End Function

Function CHGUI_UpdateTextfield(N:CHGUI)
	N.CheckOver()
	N.CheckDown()
	
	If N.Over Then CHGUI_TextBoxOver = 1
	If N.Down Then CHGUI_TextBoxDown = 1
	If N.OnFocus Then CHGUI_TextboxOnFocus = 1
	
	'Get Focus
	If N.Clicked Then
		CHGUI_TextboxFocus= N
		If N.OnFocus = 0 Then
			N.Cursor = N.Text.Length
			N.OnFocus = 1
			If CHGUI_Keyboard = 1 Then
				EnableKeyboard()
			Else If CHGUI_Keyboard = 2 Then
				CHGUI_ShowKeyboard = 1
				CHGUI_KeyboardWindow.Visible = 1
				CHGUI_ShiftHold = 0
			End If
			
			If  CHGUI_AutoTextScroll Then
				CHGUI_TargetX = - CHGUI_RealX(N)+CHGUI_OffsetX + 100
				CHGUI_TargetY = - CHGUI_RealY(N)+CHGUI_OffsetY  + 100
				CHGUI_Moving = 1
			End If
			
			
		Else
			'Work out the clicked cursor position
			Local C
			For C = 0 to N.Text.Length-1
				If (CHGUI_Font.GetTxtWidth(N.Text[..C]+"NON") - CHGUI_Font.GetTxtWidth("NON")) > TouchX()-CHGUI_RealX(N)-10 Then Exit
			Next
			N.Cursor = C
		End If
	End If
	
	'Get Text
	If N.OnFocus Then
		If CHGUI_Keyboard = 1 Then
			CHGUI_GetText(N)
		Else If CHGUI_Keyboard = 2 Then
			CHGUI_UpdateKeyboard(N)
		Else
			CHGUI_GetText(N)
		End If
	End If
	
	
	
	
	'REMOVE FOCUS

	If TouchDown() And N.Over = 0 Then
		If CHGUI_Keyboard = 2 Then 
			If TouchY() < DeviceHeight() - CHGUI_KeyboardWindow.H Then
				N.OnFocus=0
				If CHGUI_Keyboard = 1 Then
					DisableKeyboard()
				Else If CHGUI_Keyboard = 2 Then
					CHGUI_ShowKeyboard = 0
					CHGUI_KeyboardWindow.Visible = 0
					CHGUI_KeyboardPage=0
				End If
			End If
		Else
			N.OnFocus=0
			If CHGUI_Keyboard = 1 Then
				DisableKeyboard()
			Else If CHGUI_Keyboard = 2 Then
				CHGUI_ShowKeyboard = 0
				CHGUI_KeyboardWindow.Visible = 0
				CHGUI_KeyboardPage=0
			End If
		End If
	End If
	'Tooltip Flag
	If CHGUI_Tooltips = 1 And N.Tooltip <> "" And N.OverTime > CHGUI_TooltipTime Then
		If TouchDown() = 0 CHGUI_TooltipFlag = N
	End If
End Function

Function CHGUI_GetText(N:CHGUI)
	Local Before:String = N.Text[..N.Cursor]
	Local After:String = N.Text[N.Cursor..]
	Local In = GetChar()
	'MsgBox(In)
		'LCase only
	If In > 96 And In < 123 And N.FormatText = 1 And CHGUI_Font.GetTxtWidth(N.Text) < N.W -12
		Before = Before + String.FromChar(In)
		N.Cursor = N.Cursor + 1
		
		'UCase only
	ElseIf In > 64 And In < 91 And N.FormatText = 1 And CHGUI_Font.GetTxtWidth(N.Text) < N.W -12
		Before = Before + String.FromChar(In)
		N.Cursor = N.Cursor + 1
	
		'Numbers
	ElseIf In > 45 And In < 58 And N.FormatNumber = 1 And CHGUI_Font.GetTxtWidth(N.Text) < N.W -12
		If In <> 47 or N.FormatSymbol = 1 Then
			Before = Before + String.FromChar(In)
			N.Cursor = N.Cursor + 1	
		End If
		'Symbols 1
	ElseIf In > 32 And In < 48 And N.FormatSymbol = 1 And CHGUI_Font.GetTxtWidth(N.Text) < N.W -12
		Before = Before + String.FromChar(In)
		N.Cursor = N.Cursor + 1	
		
		'Symbols 2
	ElseIf In > 57 And In < 65 And N.FormatSymbol = 1 And CHGUI_Font.GetTxtWidth(N.Text) < N.W -12
		Before = Before + String.FromChar(In)
		N.Cursor = N.Cursor + 1	
		
		'Symbols 3
	ElseIf In > 90 And In < 97 And N.FormatSymbol = 1 And CHGUI_Font.GetTxtWidth(N.Text) < N.W -12
		Before = Before + String.FromChar(In)
		N.Cursor = N.Cursor + 1	
		
		'Symbols 4
	ElseIf In > 122 And In < 127 And N.FormatSymbol = 1 And CHGUI_Font.GetTxtWidth(N.Text) < N.W -12
		Before = Before + String.FromChar(In)
		N.Cursor = N.Cursor + 1
		
		'Space
	ElseIf In = 32 And N.FormatSpace = 1 And CHGUI_Font.GetTxtWidth(N.Text) < N.W -12
		Before = Before + String.FromChar(In)
		N.Cursor = N.Cursor + 1
		
	Else If In = 8
		'Backspace
		Before = Before [..(Before.Length-1)]
		If N.Cursor > 0 Then N.Cursor = N.Cursor-1
		
	Else If In = 127
		'Delete
		After = After [(1)..]
		
	Else If In = 65575 Then
		'Right
		If N.Cursor < N.Text.Length Then  N.Cursor = N.Cursor+1
		
	Else If In = 65573 Then
		'Left
		If N.Cursor > 0 Then N.Cursor = N.Cursor-1
		
	Else If In = 13 Then 
		'Enter
		N.OnFocus = 0
	End If
		
		N.Text = Before + After
End Function

Function CHGUI_UpdateTab(N:CHGUI)
	N.CheckOver()
	N.CheckDown()	
	
	If N.Clicked Then N.Parent.CurrentTab = N
	'Tooltip Flag
	If CHGUI_Tooltips = 1 And N.Tooltip <> "" And N.OverTime > CHGUI_TooltipTime Then
		If TouchDown() = 0 CHGUI_TooltipFlag = N
	End If
End Function

Function CHGUI_UpdateListbox(N:CHGUI)
	N.CheckOver()
	N.CheckDown()
	
	N.ListHeight = CHGUI_Font.GetFontHeight() + 10
	N.ListboxNumber = N.H / N.ListHeight -1
	
	N.ListboxSlider.Minimum = 0
	N.ListboxSlider.Maximum = N.ListboxItems.Length - N.ListboxNumber - 1
	
	If N.ListboxSlider.Maximum <1 Then
		N.ListboxSlider.Visible = 0
	Else
		N.ListboxSlider.Visible=1
	End If 
	'Tooltip Flag
	If CHGUI_Tooltips = 1 And N.Tooltip <> "" And N.OverTime > CHGUI_TooltipTime Then
		If TouchDown() = 0 CHGUI_TooltipFlag = N
	End If
End Function

Function CHGUI_UpdateListboxItem(N:CHGUI, C)
	N.X = 0
	N.Y = C * N.Parent.ListHeight
	N.W = N.Parent.W
	N.H = N.Parent.ListHeight
	
	N.CheckOver()
	N.CheckDown()
	
	If N.Clicked Then
		N.Parent.Text = N.Text
		N.Parent.SelectedListboxItem = N
		N.Parent.Value = N.Value
	End If
	'Tooltip Flag
	If CHGUI_Tooltips = 1 And N.Tooltip <> "" And N.OverTime > CHGUI_TooltipTime Then
		If TouchDown() = 0 CHGUI_TooltipFlag = N
	End If
	 
End Function

Function CHGUI_UpdateLabel(N:CHGUI)
	N.W = CHGUI_Font.GetTxtWidth(N.Text)
	N.H = CHGUI_Font.GetTxtHeight(N.Text)
	
	N.CheckOver()
	N.CheckDown()
End Function
'#EndRegion 


'#Region DRAWING FUNCTIONS
Function CHGUI_DrawContents(N:CHGUI)
	Local X
	Local XX
	Local XOffset
	Local C
	
	'Draw the Window
	If N.Element <> "Tab" Then
		If N.Parent <> Null Then
			If CHGUI_RealVisible(N)=1 And CHGUI_RealMinimised(N.Parent)=0  Then CHGUI_DrawWindow(N)
		Else
			CHGUI_DrawWindow(N)
		End If
	End If
	
	'Draw the buttons
	For X = 0 to N.Buttons.Length-1
		If CHGUI_RealVisible(N.Buttons[X]) And CHGUI_RealMinimised(N.Buttons[X])=0 Then CHGUI_DrawButton(N.Buttons[X])
	Next
	
	'Draw the Imagebuttons
	For X = 0 to N.ImageButtons.Length-1
		If CHGUI_RealVisible(N.ImageButtons[X]) And CHGUI_RealMinimised(N.ImageButtons[X])=0 Then CHGUI_DrawImageButton(N.ImageButtons[X])
	Next
	
	'Draw the Tickboxes
	For X = 0 to N.Tickboxes.Length-1
		If CHGUI_RealVisible(N.Tickboxes[X]) And CHGUI_RealMinimised(N.Tickboxes[X])=0 Then CHGUI_DrawTickbox(N.Tickboxes[X])
	Next
		
	'Draw the Radioboxes
	For X = 0 to N.Radioboxes.Length-1
		If CHGUI_RealVisible(N.Radioboxes[X])And CHGUI_RealMinimised(N.Radioboxes[X])=0 Then CHGUI_DrawRadiobox(N.Radioboxes[X])
	Next
	
	'Draw the Listboxes
	For X = 0 to N.Listboxes.Length-1
		If CHGUI_RealVisible(N.Listboxes[X]) And CHGUI_RealMinimised(N.Listboxes[X])=0 Then
			CHGUI_DrawListbox(N.Listboxes[X])
			'Draw the ListboxItems
			Local C = 0
		
			For XX = Int(N.Listboxes[X].ListboxSlider.Value) to N.Listboxes[X].ListboxSlider.Value + N.Listboxes[X].ListboxNumber
				If XX < N.Listboxes[X].ListboxItems.Length And XX >-1 Then
					If CHGUI_RealVisible(N.Listboxes[X].ListboxItems[XX]) And CHGUI_RealMinimised(N.Listboxes[X].ListboxItems[XX])=0 Then
						CHGUI_DrawListboxItem(N.Listboxes[X].ListboxItems[XX],C)
						C = C + 1
					End If
				End If
			Next
		End If
	Next
	
	'Draw the HSliders
	For X = 0 to N.HSliders.Length-1
		If CHGUI_RealVisible(N.HSliders[X])And CHGUI_RealMinimised(N.HSliders[X])=0 Then CHGUI_DrawHSlider(N.HSliders[X])
	Next
	
	'Draw the VSliders
	For X = 0 to N.VSliders.Length-1
		If CHGUI_RealVisible(N.VSliders[X])And CHGUI_RealMinimised(N.VSliders[X])=0 Then CHGUI_DrawVSlider(N.VSliders[X])
	Next
	
	'Draw the Textfields
	For X = 0 to N.Textfields.Length-1
		If CHGUI_RealVisible(N.Textfields[X])And CHGUI_RealMinimised(N.Textfields[X])=0 Then CHGUI_DrawTextfield(N.Textfields[X])
	Next
	
	
	'Draw the Labels
	For X = 0 to N.Labels.Length-1
		If CHGUI_RealVisible(N.Labels[X]) And CHGUI_RealMinimised(N.Labels[X])=0 Then CHGUI_DrawLabel(N.Labels[X])
	Next
	
	'Draw the Dropdowns
	For X = 0 to N.Dropdowns.Length-1
		If CHGUI_RealVisible(N.Dropdowns[X]) And CHGUI_RealMinimised(N.Dropdowns[X])=0 Then 
			CHGUI_DrawDropdown(N.Dropdowns[X])
		End If
	Next
	
	'Draw the DropdownItems
	For X = 0 to N.Dropdowns.Length-1
		If N.Dropdowns[X].OnFocus=1 Then
			C = 0
			For XX = 0 to N.Dropdowns[X].DropdownItems.Length-1
				If CHGUI_RealMinimised(N.Dropdowns[X])=0 And CHGUI_RealVisible(N.Dropdowns[X].DropdownItems[XX]) Then CHGUI_DrawDropdownItem(N.Dropdowns[X].DropdownItems[XX],C)
				If CHGUI_RealMinimised(N.Dropdowns[X])=0 And CHGUI_RealVisible(N.Dropdowns[X].DropdownItems[XX]) Then C = C+1
			Next
			If N.Dropdowns.Length > 0 Then N.Dropdowns[X].DropNumber = C-1
		End If
	Next
	
	'Draw the Menus
	XOffset=0
	N.HasMenu = 0
	C = 0
	For X = 0 to N.Menus.Length-1
		If CHGUI_RealMinimised(N.Menus[X])=0 And CHGUI_RealVisible(N.Menus[X]) Then CHGUI_DrawMenu(N.Menus[X],XOffset,C)
		If CHGUI_RealMinimised(N.Menus[X])=0 And CHGUI_RealVisible(N.Menus[X]) Then XOffset = XOffset + N.Menus[X].W
		If CHGUI_RealMinimised(N.Menus[X])=0 And CHGUI_RealVisible(N.Menus[X]) Then C=C+1
	Next	
	
	'Draw the Tabs
		C = 5
		N.Tabbed = 0
		For X = 0 to N.Tabs.Length-1
			If CHGUI_RealMinimised(N.Tabs[X])=0 And CHGUI_RealVisible(N.Tabs[X]) Then CHGUI_DrawTab(N.Tabs[X],C)
			If CHGUI_RealMinimised(N.Tabs[X])=0 And CHGUI_RealVisible(N.Tabs[X]) Then C=C+N.Tabs[X].W
		Next	
	
	'Draw The SubWindows
	For Local NN = 0 to N.BottomList.Length-1
			If N.BottomList[NN].Visible Then CHGUI_DrawContents(N.BottomList[NN])
	Next
	For Local NN = 0 to N.VariList.Length-1
			If N.VariList[NN].Visible Then CHGUI_DrawContents(N.VariList[NN])
	Next
	For Local NN = 0 to N.TopList.Length-1
			If N.TopList[NN].Visible Then CHGUI_DrawContents(N.TopList[NN])
	Next
	
	If N.Tabbed Then
		CHGUI_DrawContents(N.CurrentTab)
	End If
	
	'Draw the MenuItems
	For X = 0 to N.Menus.Length-1
		CHGUI_SubMenu(N.Menus[X])
	Next
	

End Function


Function CHGUI_DrawWindow(N:CHGUI)

	Local X:Float = CHGUI_RealX(N)
	Local Y:Float = CHGUI_RealY(N)
	Local W:Float = N.W
	Local H:Float = N.H
	Local TH:Float = CHGUI_TitleHeight
	Local Active = CHGUI_RealActive(N)
	If CHGUI_LockedWIndow = N Then Active = 1
	
If N <> CHGUI_Canvas Then	
	'Shadows
	If N.Shadow And CHGUI_Shadow Then
		If N.Minimised Then
			'TopLeft
			DrawImageRect(CHGUI_ShadowImg,X-10,Y-10,0,0,20,20)
			'TopMiddle
			DrawImageRect(CHGUI_ShadowImg,X+10,Y-10,20,0,10,10,0,(W-20)/10,1)
			'TopRight
			DrawImageRect(CHGUI_ShadowImg,X+W-10,Y-10,30,0,20,20)
			'Left
			DrawImageRect(CHGUI_ShadowImg,X-10,Y+10,0,20,10,10,0,1,(TH-20)/10)
			'Right
			DrawImageRect(CHGUI_ShadowImg,X+W,Y+10,40,20,10,10,0,1,(TH-20)/10)
			'BottomLeft
			DrawImageRect(CHGUI_ShadowImg,X-10,Y+TH-10,0,30,20,20)
			'BottomMiddle
			DrawImageRect(CHGUI_ShadowImg,X+10,Y+TH,20,40,10,10,0,(W-20)/10,1)
			'BottomRight
			DrawImageRect(CHGUI_ShadowImg,X+W-10,Y+TH-10,30,30,20,20)
		Else
			'TopLeft
			DrawImageRect(CHGUI_ShadowImg,X-10,Y-10,0,0,20,20)
			'TopMiddle
			DrawImageRect(CHGUI_ShadowImg,X+10,Y-10,20,0,10,10,0,(W-20)/10,1)
			'TopRight
			DrawImageRect(CHGUI_ShadowImg,X+W-10,Y-10,30,0,20,20)
			'Left
			DrawImageRect(CHGUI_ShadowImg,X-10,Y+10,0,20,10,10,0,1,(H-20)/10)
			'Right
			DrawImageRect(CHGUI_ShadowImg,X+W,Y+10,40,20,10,10,0,1,(H-20)/10)
			'BottomLeft
			DrawImageRect(CHGUI_ShadowImg,X-10,Y+H-10,0,30,20,20)
			'BottomMiddle
			DrawImageRect(CHGUI_ShadowImg,X+10,Y+H,20,40,10,10,0,(W-20)/10,1)
			'BottomRight
			DrawImageRect(CHGUI_ShadowImg,X+W-10,Y+H-10,30,30,20,20)
		End If
	End If
	
	Local XOf:Float = 10
	Local YOf:Float = 10
	If CHGUI_RealActive(N)=0 And CHGUI_LockedWIndow <> N Then YOf = YOf + 30
	
	
	If N.Text <> "" Then
			'Titlebar TopLeft
			DrawImageRect(CHGUI_Style,X,Y,XOf,YOf,10,10)	
			'Titlebar TopMiddle
			DrawImageRect(CHGUI_Style,X+10,Y,XOf+10,YOf,50,10,0,(W-20)/50,1)
			'Titlebar TopRight
			DrawImageRect(CHGUI_Style,X+W-10,Y,XOf+60,YOf,10,10)
			'Titlebar Left
			DrawImageRect(CHGUI_Style,X,Y+10,XOf,YOf+10,10,10,0,1,(TH-20)/10)	
			'Titlebar Middle
			DrawImageRect(CHGUI_Style,X+10,Y+10,XOf+10,YOf+10,50,10,0,(W-20)/50,(TH-20)/10)
			'Titlebar Right
			DrawImageRect(CHGUI_Style,X+W-10,Y+10,XOf+60,YOf+10,10,10,0,1,(TH-20)/10)
			'Titlebar BottomLeft
			DrawImageRect(CHGUI_Style,X,Y+TH-10,XOf,YOf+20,10,10)	
			'Titlebar BottomMiddle
			DrawImageRect(CHGUI_Style,X+10,Y+TH-10,XOf+10,YOf+20,50,10,0,(W-20)/50,1)
			'Titlebar BottomRight
			DrawImageRect(CHGUI_Style,X+W-10,Y+TH-10,XOf+60,YOf+20,10,10)	
	End If
	
	If N.Minimised = 0 Then
		If N.Text = "" Then
			'Window Top Left
			DrawImageRect(CHGUI_Style,X,Y,10,70,10,10,0,1,1)	
			'Window Top
			DrawImageRect(CHGUI_Style,X+10,Y,20,70,50,10,0,(W-20)/50,1)
			'Window Top Right
			DrawImageRect(CHGUI_Style,X+W-10,Y,70,70,10,10,0,1,1)	
			'Window Left
			DrawImageRect(CHGUI_Style,X,Y+10,10,80,10,40,0,1,(H-20)/40)	
			'Window Right
			DrawImageRect(CHGUI_Style,X+W-10,Y+10,70,80,10,40,0,1,(H-20)/40)	
			'Middle
			DrawImageRect(CHGUI_Style,X+10,Y+10,20,80,50,40,0,(W-20)/50,(H-20)/40)
			'Window Bottom Left
			DrawImageRect(CHGUI_Style,X,Y+H-10,10,120,10,10,0,1,1)
			'Window Bottom
			DrawImageRect(CHGUI_Style,X+10,Y+H-10,20,120,50,10,0,(W-20)/50,1)
			'Window Bottom Right
			DrawImageRect(CHGUI_Style,X+W-10,Y+H-10,70,120,10,10,0,1,1)
		Else
			'Window Left
			DrawImageRect(CHGUI_Style,X,Y+TH,10,80,10,40,0,1,(H-TH-10)/40)	
			'Window Right
			DrawImageRect(CHGUI_Style,X+W-10,Y+TH,70,80,10,40,0,1,(H-TH-10)/40)	
			'Middle
			DrawImageRect(CHGUI_Style,X+10,Y+TH,20,80,50,40,0,(W-20)/50,(H-TH-10)/40)
			'Window Bottom Left
			DrawImageRect(CHGUI_Style,X,Y+H-10,10,120,10,10,0,1,1)
			'Window Bottom
			DrawImageRect(CHGUI_Style,X+10,Y+H-10,20,120,50,10,0,(W-20)/50,1)
			'Window Bottom Right
			DrawImageRect(CHGUI_Style,X+W-10,Y+H-10,70,120,10,10,0,1,1)
		End If
	End If
	
	'Close Button
	If N.Close = 1 Then
		If N.CloseOver And N.CloseDown = 0 Then
			DrawImageRect(CHGUI_Style,X+W-(TH/2.5)-10,Y+(TH-TH/2.5)/2,105,10,15,15,0,(TH/2.5)/15,(TH/2.5)/15)
		Else If N.CloseDown
			DrawImageRect(CHGUI_Style,X+W-(TH/2.5)-10,Y+(TH-TH/2.5)/2,120,10,15,15,0,(TH/2.5)/15,(TH/2.5)/15)
		ElseIf Active
			DrawImageRect(CHGUI_Style,X+W-(TH/2.5)-10,Y+(TH-TH/2.5)/2,90,10,15,15,0,(TH/2.5)/15,(TH/2.5)/15)
		Else
			DrawImageRect(CHGUI_Style,X+W-(TH/2.5)-10,Y+(TH-TH/2.5)/2,135,10,15,15,0,(TH/2.5)/15,(TH/2.5)/15)
		End If	
	End If
	
	'Minimise Button
	If N.Minimise = 1 Then
		If N.MinimiseOver And N.MinimiseDown = 0 Then
			DrawImageRect(CHGUI_Style,X+W-(TH/2.5 + TH/2.5)-TH/1.5,Y+(TH-TH/2.5)/2,105,25,15,15,0,(TH/2.5)/15,(TH/2.5)/15)
		Else If N.MinimiseDown
			DrawImageRect(CHGUI_Style,X+W-(TH/2.5 + TH/2.5)-TH/1.5,Y+(TH-TH/2.5)/2,120,25,15,15,0,(TH/2.5)/15,(TH/2.5)/15)
		ElseIf Active
			DrawImageRect(CHGUI_Style,X+W-(TH/2.5 + TH/2.5)-TH/1.5,Y+(TH-TH/2.5)/2,90,25,15,15,0,(TH/2.5)/15,(TH/2.5)/15)
		Else
			DrawImageRect(CHGUI_Style,X+W-(TH/2.5 + TH/2.5)-TH/1.5,Y+(TH-TH/2.5)/2,135,25,15,15,0,(TH/2.5)/15,(TH/2.5)/15)
		End If	
	End If
	
	
	
	
	
	'Title
	Local XOff:Float = (TH -(TH/2))/2
	Local YOff:Float = TH - CHGUI_TextHeight(CHGUI_TitleFont,N.Text)
	SetAlpha 0.25
	If Active Then SetAlpha 1
	CHGUI_TitleFont.DrawText(N.Text,X+XOff,Y+YOff/2)
	SetAlpha 1
End If	
	'Menu Bar
	If N.HasMenu Then
		If N <> CHGUI_Canvas Then
			If CHGUI_Shadow Then DrawImageRect(CHGUI_ShadowImg,X,Y+TH+N.MenuHeight,20,40,10,10,0,(W)/10,1)
			DrawImageRect(CHGUI_Style,X+1,Y+CHGUI_TitleHeight,100,90,40,10,0,(W-2)/40,(10 + CHGUI_TextHeight(CHGUI_Font,N.Text)-10)/10)
			DrawImageRect(CHGUI_Style,X+1,Y+CHGUI_TitleHeight+(N.MenuHeight-10),100,100,40,10,0,(W-2)/40,1)
		Else
			If CHGUI_Shadow Then DrawImageRect(CHGUI_ShadowImg,X,Y+N.MenuHeight,20,40,10,10,0,(W)/10,1)
			DrawImageRect(CHGUI_Style,X+1,Y,100,90,40,10,0,(W-2)/40,(10 + CHGUI_TextHeight(CHGUI_Font,N.Text)-10)/10)
			DrawImageRect(CHGUI_Style,X+1,Y+(N.MenuHeight-10),100,100,40,10,0,(W-2)/40,1)
		End If
	End If
	
	'Tab Bar
	If N.Tabbed And N.Minimised =0 Then
		Local YY = Y+ N.MenuHeight
		If N.Text <> "" Then YY = YY + CHGUI_TitleHeight
		Local Height:Float = N.TabHeight + 5
		
		'TopLeft
		DrawImageRect(CHGUI_Style,X+1,YY,10,140,10,10)
		'TopRight
		DrawImageRect(CHGUI_Style,X+W-11,YY,60,140,10,10)
		'TopMiddle
		DrawImageRect(CHGUI_Style,X+11,YY,20,140,40,10,0,(W-22)/40,1)
		'Left
		DrawImageRect(CHGUI_Style,X+1,YY+10,10,150,10,10,0,1,(Height-10)/10)
		'Right
		DrawImageRect(CHGUI_Style,X+W-11,YY+10,60,150,10,10,0,1,(Height-10)/10)
		'Middle
		DrawImageRect(CHGUI_Style,X+11,YY+10,20,150,40,10,0,(N.W-22)/40,(Height-10)/10)
		'BottomLeft
		DrawImageRect(CHGUI_Style,X+1,YY+Height-10,10,160,10,10)
		'BottomRight
		DrawImageRect(CHGUI_Style,X+W-11,YY+Height-10,60,160,10,10)
		'BottomMiddle
		DrawImageRect(CHGUI_Style,X+11,YY+Height-10,20,160,40,10,0,(W-22)/40,1)
		
	End If
End Function

Function CHGUI_DrawButton(N:CHGUI)
	Local X:Float = CHGUI_RealX(N)
	Local Y:Float = CHGUI_RealY(N)
	Local W:Float = N.W
	Local H:Float = N.H
	Local Active=CHGUI_RealActive(N)
	Local State
	If N.Over Then State = 40
	If N.Down Then State = 80
	If N = CHGUI_KeyboardButtons[104] And CHGUI_ShiftHold Then State = 80
	If Active = 0 Then State = 120
	
	
	
	'Top Left
	DrawImageRect(CHGUI_Style,X,Y,160,10+State,10,10)
	'Top
	DrawImageRect(CHGUI_Style,X+10,Y,170,10+State,40,10,0,(W-20)/40,1)
	'Top Right
	DrawImageRect(CHGUI_Style,X+W-10,Y,210,10+State,10,10)
	'Left
	DrawImageRect(CHGUI_Style,X,Y+10,160,20+State,10,20,0,1,(H-20)/20)
	'Right
	DrawImageRect(CHGUI_Style,X+W-10,Y+10,210,20+State,10,20,0,1,(H-20)/20)
	'Middle
	DrawImageRect(CHGUI_Style,X+10,Y+10,170,20+State,40,20,0,(W-20)/40,(H-20)/20)
	'Bottom Left
	DrawImageRect(CHGUI_Style,X,Y+H-10,160,40+State,10,10)
	'Bottom
	DrawImageRect(CHGUI_Style,X+10,Y+H-10,170,40+State,40,10,0,(W-20)/40,1)
	'Bottom Right
	DrawImageRect(CHGUI_Style,X+W-10,Y+H-10,210,40+State,10,10)
	
	'Text
	Local XOff:Float = (W-(CHGUI_Font.GetTxtWidth(N.Text) ))/2
	Local YOff:Float =( H - CHGUI_TextHeight(CHGUI_Font,N.Text))/2
	SetAlpha 0.25
	If Active Then SetAlpha 1
	CHGUI_Font.DrawText(N.Text,X+XOff,Y+YOff)
	SetAlpha 1
	
	
End Function

Function CHGUI_DrawLabel(N:CHGUI)
	Local X:Float = CHGUI_RealX(N)
	Local Y:Float = CHGUI_RealY(N)
	Local Active=CHGUI_RealActive(N)
	
	'Text
	Local XOff:Float
	Local YOff:Float

	SetAlpha 0.25
	If Active Then SetAlpha 1
	CHGUI_Font.DrawText(N.Text,X,Y)
	SetAlpha 1
	
	
End Function

Function CHGUI_DrawImageButton(N:CHGUI)
	Local X:Float = CHGUI_RealX(N)
	Local Y:Float = CHGUI_RealY(N)
	Local W:Float = N.W
	Local H:Float = N.H
	Local Active=CHGUI_RealActive(N)
	Local State
	If N.Over Then State = W
	If N.Down Then State = W*2
	If Active = 0 Then State = W*3
	
	DrawImageRect(N.Img,X,Y,State,0,W,H)
	
	
End Function

Function CHGUI_DrawTickbox(N:CHGUI)
	Local X:Float = CHGUI_RealX(N)
	Local Y:Float = CHGUI_RealY(N)
	Local W:Float = N.H
	Local H:Float = N.H
	Local Active=CHGUI_RealActive(N)
	Local OffX = 230
	Local OffY = 10
	Local OffW = 20
	Local OffH = 20
	If N.Over Then  OffY = 30
	If N.Down Then OffY = 50
	If Active = 0 Then OffY = 70
	If N.Value > 0 Then OffX = 250
	
	'Draw The Tickbox
	DrawImageRect(CHGUI_Style,X,Y,OffX,OffY,OffW,OffH,0,W/OffW,H/OffH)
	'Draw the label
	Local XOff:Float = (W/4)
	Local YOff:Float =( H - CHGUI_TextHeight(CHGUI_Font,N.Text))/2
	SetAlpha 0.25
	If Active Then SetAlpha 1
	CHGUI_Font.DrawText(N.Text,X+W+XOff,Y+YOff)
	SetAlpha 1


End Function

Function CHGUI_DrawRadiobox(N:CHGUI)
	Local X:Float = CHGUI_RealX(N)
	Local Y:Float = CHGUI_RealY(N)
	Local W:Float = N.H
	Local H:Float = N.H
	Local Active=CHGUI_RealActive(N)
	Local OffX = 230
	Local OffY = 100
	Local OffW = 20
	Local OffH = 20
	If N.Over Then  OffY = 120
	If N.Down Then OffY = 140
	If Active = 0 Then OffY = 160
	If N.Value > 0 Then OffX = 250
	
	'Draw The Radiobox
	DrawImageRect(CHGUI_Style,X,Y,OffX,OffY,OffW,OffH,0,W/OffW,H/OffH)
	'Draw the label
	Local XOff:Float = (W/4)
	Local YOff:Float =( H - CHGUI_TextHeight(CHGUI_Font,N.Text))/2
	SetAlpha 0.25
	If Active Then SetAlpha 1
	CHGUI_Font.DrawText(N.Text,X+W+XOff,Y+YOff)
	SetAlpha 1


End Function

Function CHGUI_DrawDropdown(N:CHGUI)
	Local X:Float = CHGUI_RealX(N)
	Local Y:Float = CHGUI_RealY(N)
	Local W:Float = N.W
	Local H:Float = N.H
	Local Active=CHGUI_RealActive(N)
	
	Local OffX = 280
	Local OffY = 10
	If N.Over Then  OffY =50
	If N.Down Or N.OnFocus Then OffY = 90
	If Active = 0 Then OffY = 130
	
	'TopLeft
	DrawImageRect(CHGUI_Style,X,Y,OffX,OffY,10,10)
	'TopMiddle
	DrawImageRect(CHGUI_Style,X+10,Y,OffX+10,OffY,10,10,0,(W-20)/10,1)
	'TopRight
	DrawImageRect(CHGUI_Style,X+W-10,Y,OffX+30,OffY,10,10)	
	'Left
	DrawImageRect(CHGUI_Style,X,Y+10,OffX,OffY+10,10,10,0,1,(H-20)/10)
	'Right
	DrawImageRect(CHGUI_Style,X+W-10,Y+10,OffX+30,OffY+10,10,10,0,1,(H-20)/10)
	'Middle
	DrawImageRect(CHGUI_Style,X+10,Y+10,OffX+10,OffY+10,20,20,0,(W-20)/20,(H-20)/20)
	'BottomLeft
	DrawImageRect(CHGUI_Style,X,Y+H-10,OffX,OffY+30,10,10)
	'BottomMiddle
	DrawImageRect(CHGUI_Style,X+10,Y+H-10,OffX+10,OffY+30,10,10,0,(W-20)/10,1)	
	'BottomLeft
	DrawImageRect(CHGUI_Style,X+W-10,Y+H-10,OffX+30,OffY+30,10,10)
	
	'Button
	DrawImageRect(CHGUI_Style,X+W-H,Y,OffX+40,OffY,40,40,0,(H)/40,H/40)
	
	'Draw the label
	Local YOff:Float =( H - CHGUI_TextHeight(CHGUI_Font,N.Text))/2
	SetAlpha 0.25
	If Active Then SetAlpha 1
	CHGUI_Font.DrawText(N.Text,X+5,Y+YOff)
	SetAlpha 1
	


End Function

Function CHGUI_DrawDropdownItem(N:CHGUI,C)
	N.X = 0
	N.Y = (C+1) * N.Parent.H
	N.W = N.Parent.W
	N.H = N.Parent.H
	
	Local X:Float = CHGUI_RealX(N)
	Local Y:Float = CHGUI_RealY(N)
	Local W:Float = N.Parent.W
	Local H:Float = N.Parent.H
	Local Active=CHGUI_RealActive(N)
	
	Local OffX = 90
	Local OffY = 80
	Local OffH = 30
	
	If N.Over Then  OffY = 110
	If N.Down And CHGUI_RealActive(N) Then OffY = 140
	
	If  C <> 0 And C <> N.Parent.DropNumber Then
		'Left
		DrawImageRect(CHGUI_Style,X,Y,OffX,OffY+10,10,10,0,1,(H)/10)
		'Right
		DrawImageRect(CHGUI_Style,X+W-10,Y,OffX+50,OffY+10,10,10,0,1,(H)/10)
		'Middle
		DrawImageRect(CHGUI_Style,X+10,Y,OffX+10,OffY+10,40,10,0,(W-20)/40,(H)/10)
		'Shadow Left and Right 
		If CHGUI_Shadow Then
			DrawImageRect(CHGUI_ShadowImg,X+W,Y,40,20,10,10,0,1,(H)/10)
			DrawImageRect(CHGUI_ShadowImg,X-10,Y,0,20,10,10,0,1,(H)/10)
		End If
	End If
	'Top Boarder
	If C = 0 Then
		'Shadows
		If CHGUI_Shadow Then
			DrawImageRect(CHGUI_ShadowImg,X+W,Y+10,40,20,10,10,0,1,(H-10)/10)
			DrawImageRect(CHGUI_ShadowImg,X-10,Y+10,0,20,10,10,0,1,(H-10)/10)
			'TopLeft
			DrawImageRect(CHGUI_ShadowImg,X-10,Y-10,0,0,10,20)
			'TopRight
			DrawImageRect(CHGUI_ShadowImg,X+W,Y-10,40,0,10,20)
		End If

		'TopLeft
		DrawImageRect(CHGUI_Style,X,Y,OffX,OffY,10,10,0,1,1)
		'Top
		DrawImageRect(CHGUI_Style,X+10,Y,OffX+10,OffY,40,10,0,(W-20)/40,1)
		'TopRight
		DrawImageRect(CHGUI_Style,X+W-10,Y,OffX+50,OffY,10,10,0,1,1)
		'Left
		DrawImageRect(CHGUI_Style,X,Y+10,OffX,OffY+10,10,10,0,1,(H-10)/10)
		'Right
		DrawImageRect(CHGUI_Style,X+W-10,Y+10,OffX+50,OffY+10,10,10,0,1,(H-10)/10)
		'Middle
		DrawImageRect(CHGUI_Style,X+10,Y+10,OffX+10,OffY+10,40,10,0,(W-20)/40,(H-10)/10)
	End If
	'Bottom Boarder
	If C = N.Parent.DropNumber Then
		'Shadows
		If CHGUI_Shadow Then
			DrawImageRect(CHGUI_ShadowImg,X+W,Y,40,20,10,10,0,1,(H-10)/10)
			DrawImageRect(CHGUI_ShadowImg,X-10,Y,0,20,10,10,0,1,(H-10)/10)	
			'BottomMiddle
			DrawImageRect(CHGUI_ShadowImg,X+10,Y+H,20,40,10,10,0,(W-20)/10,1)
			'BottomRight
			DrawImageRect(CHGUI_ShadowImg,X+W-10,Y+H-10,30,30,20,20)
			'BottomLeft
			DrawImageRect(CHGUI_ShadowImg,X-10,Y+H-10,0,30,20,20)
		End If
		'Left
		DrawImageRect(CHGUI_Style,X,Y,OffX,OffY+10,10,10,0,1,(H-10)/10)
		'Right
		DrawImageRect(CHGUI_Style,X+W-10,Y,OffX+50,OffY+10,10,10,0,1,(H-10)/10)
		'Middle
		DrawImageRect(CHGUI_Style,X+10,Y,OffX+10,OffY+10,40,10,0,(W-20)/40,(H-10)/10)
		'Bottom Left
		DrawImageRect(CHGUI_Style,X,Y+H-10,OffX,OffY+20,10,10,0,1,1)
		'Bottom 
		DrawImageRect(CHGUI_Style,X+10,Y+H-10,OffX+10,OffY+20,40,10,0,(W-20)/40,1)
		'Bottom Right
		DrawImageRect(CHGUI_Style,X+W-10,Y+H-10,OffX+50,OffY+20,10,10,0,1,1)
	End If
	
	'Draw the label
	Local YOff:Float =( H - CHGUI_TextHeight(CHGUI_Font,N.Text))/2
	SetAlpha 0.25
	If Active Then SetAlpha 1
	CHGUI_Font.DrawText(N.Text,X+5,Y+YOff)
	SetAlpha 1
End Function

Function CHGUI_DrawMenu(N:CHGUI,XOffset,C)
	If C = 0 Then XOffset = XOffset+1
	N.X = XOffset-C
	If N.Parent <> CHGUI_Canvas And N.Parent.Text <> "" Then
		N.Y = CHGUI_TitleHeight
	Else
		N.Y = 0
	End If
	N.W = 20 + CHGUI_Font.GetTxtWidth(N.Text)
	N.H = 10 + CHGUI_TextHeight(CHGUI_Font,N.Text)
	N.Parent.HasMenu = 1
	N.Parent.MenuHeight = N.H
	Local X:Float = CHGUI_RealX(N)
	Local Y:Float = CHGUI_RealY(N)
	Local W:Float = N.W
	Local H:Float = N.H
	Local Active=CHGUI_RealActive(N)
	Local OffX = 100
	Local OffY = 90
	If N.Over Then  OffY = 120
	If N.Down Or N.OnFocus Then
		If Active = 1 Then OffY = 150
	End If
	
	'Draw The BG
	DrawImageRect(CHGUI_Style,X,Y,OffX,OffY,40,10,0,W/40,(H-10)/10)
	DrawImageRect(CHGUI_Style,X,Y+(H-10),OffX,OffY+10,40,10,0,W/40,1)
	
	'Draw the Text
	Local XOff:Float = ((W)-(CHGUI_Font.GetTxtWidth(N.Text)))/2
	Local YOff:Float =( H - CHGUI_TextHeight(CHGUI_Font,N.Text))/2
	SetAlpha 0.25
	If Active Then SetAlpha 1
	CHGUI_Font.DrawText(N.Text,X+XOff,Y+YOff)
	SetAlpha 1


End Function

Function CHGUI_DrawMenuItem(N:CHGUI,C)
	If N.Parent.Element <> "MenuItem" Then
		N.X =0
		N.Y = N.Parent.H+(C*N.Parent.H)-C
		N.Parent.HasMenu = 1
		N.Parent.MenuHeight = N.H
	End If
	If N.Parent.Element = "MenuItem" Then
		N.X = N.Parent.W-1
		N.Y = ((C)*N.Parent.H)-C		
	End If
	
	N.H = 10 + CHGUI_TextHeight(CHGUI_Font,N.Text)
	N.W = 20 + CHGUI_Font.GetTxtWidth(N.Text)
	
	If N.IsMenuParent Then N.W =N.W+N.H/3
	If N.Tick Then N.W = N.W+N.H/3
	
	If N.W > N.Parent.MenuWidth Then N.Parent.MenuWidth = N.W 
	If N.Parent.MenuWidth > N.W Then N.W = N.Parent.MenuWidth
	
	If N.Tick Then
		If N.Parent.MenuWidth + N.H < N.W Then N.Parent.MenuWidth = N.W + N.H
	Else
		If N.Parent.MenuWidth < N.W Then N.Parent.MenuWidth = N.W
	End If
	
	Local X:Float = CHGUI_RealX(N)
	Local Y:Float = CHGUI_RealY(N)
	Local W:Float = N.W
	Local H:Float = N.H
	Local Active=CHGUI_RealActive(N)
	
	Local OffX = 100
	Local OffY = 90
	If N.Over Or N.OnFocus Then  OffY = 120
	If N.Down And CHGUI_RealActive(N) Then OffY = 150
'	If Active = 0 Then OffY = 90

	If C = N.Parent.MenuNumber And CHGUI_Shadow Then
		DrawImageRect(CHGUI_ShadowImg,X+W,Y,40,20,10,10,0,1,(H-10)/10)
		DrawImageRect(CHGUI_ShadowImg,X-10,Y,0,20,10,10,0,1,(H-10)/10)	
		'BottomMiddle
		DrawImageRect(CHGUI_ShadowImg,X+10,Y+H,20,40,10,10,0,(W-20)/10,1)
		'BottomRight
		DrawImageRect(CHGUI_ShadowImg,X+W-10,Y+H-10,30,30,20,20)
		'BottomLeft
		DrawImageRect(CHGUI_ShadowImg,X-10,Y+H-10,0,30,20,20)
	End If
	
	'Draw The BG				
	DrawImageRect(CHGUI_Style,X+10,Y,OffX,OffY,40,10,0,(W-20)/40,H/10)
	DrawImageRect(CHGUI_Style,X,Y,OffX-10,OffY,10,10,0,1,H/10)
	DrawImageRect(CHGUI_Style,X+W-10,Y,OffX+40,OffY,10,10,0,1,H/10)
	
	'Shadow
	If CHGUI_Shadow And C <> N.Parent.MenuNumber Then
		'Right
		DrawImageRect(CHGUI_ShadowImg,X+W,Y,40,20,10,10,0,1,(H-1)/10)
		'Left
		DrawImageRect(CHGUI_ShadowImg,X-10,Y,0,20,10,10,0,1,(H-1)/10)	
	End If
	
	'Top And Bottom
	If C = N.Parent.MenuNumber Then
		DrawImageRect(CHGUI_Style,X,Y+(H-10),OffX-10,OffY+10,10,10)
		DrawImageRect(CHGUI_Style,X+10,Y+(H-10),OffX,OffY+10,40,10,0,(W-20)/40,1)
		DrawImageRect(CHGUI_Style,X+W-10,Y+(H-10),OffX+40,OffY+10,10,10)
	
	End If
	If C = 0 Then	
		DrawImageRect(CHGUI_Style,X,Y,OffX-10,OffY-10,10,10)
		DrawImageRect(CHGUI_Style,X+10,Y,OffX,OffY-10,40,10,0,(W-20)/40,1)
		DrawImageRect(CHGUI_Style,X+W-10,Y,OffX+40,OffY-10,10,10)
	End If
	
	'Tick
	If N.Tick Then
		Local XOF = 230
		Local YOF = 10
		If N.Over Then YOF = 30
		If N.Down Then YOF = 50
		If CHGUI_RealActive(N)=0 Then XOF = 70
		If N.Value > 0 Then XOF = 250
		
		DrawImageRect(CHGUI_Style,X+5,Y+((H-(H/2.6))/2),XOF,YOF,20,20,0,(H/2.6)/20,(H/2.6)/20)
		
	End If
	
	
	
	'Draw the Text
	Local YOff:Float =( H - CHGUI_TextHeight(CHGUI_Font,N.Text))/2
	SetAlpha 0.25
	If Active Then SetAlpha 1
	If N.Tick = 0 Then
		CHGUI_Font.DrawText(N.Text,X+10,Y+YOff)
	Else
		CHGUI_Font.DrawText(N.Text,X+10+(H/2),Y+YOff)
	End If
	SetAlpha 1
	
	'Draw the Arrow
	If N.IsMenuParent Then
		If CHGUI_RealActive(N) = 1 Then
			DrawImageRect(CHGUI_Style,X+W-(H/4)-8,Y+(H-H/4)/2,130,180,10,10,0,(H/4)/10,(H/4)/10)
		Else
			DrawImageRect(CHGUI_Style,X+W-(H/4)-8,Y+(H-H/4)/2,140,180,10,10,0,(H/4)/10,(H/4)/10)
		End If
	End If
End Function

Function CHGUI_SubMenu(N:CHGUI)		
	Local C
	Local XX
			If N.OnFocus Then
			C = 0
			N.HasMenu = 0			
			For XX = 0 to N.MenuItems.Length-1
				If CHGUI_RealMinimised(N.MenuItems[XX])=0 And CHGUI_RealVisible(N.MenuItems[XX])Then CHGUI_DrawMenuItem(N.MenuItems[XX],C)
				If CHGUI_RealMinimised(N.MenuItems[XX])=0 And CHGUI_RealVisible(N.MenuItems[XX])Then C=C+1
			Next
			If N.MenuItems.Length > 0 Then N.MenuNumber = C-1
			For XX = 0 to N.MenuItems.Length-1
				If N.MenuItems[XX].IsMenuParent Then CHGUI_SubMenu(N.MenuItems[XX])
			Next
		End If
End Function

Function CHGUI_DrawHSlider(N:CHGUI)
	Local X:Float = CHGUI_RealX(N)
	Local Y:Float = CHGUI_RealY(N)
	Local W:Float = N.W
	Local H:Float = N.H
	Local Active=CHGUI_RealActive(N)
	
	Local OffX = 460
	Local OffY = 10

	If Active = 0 Then OffY = 70
	
	'Left Arrow
	If N.MinusOver And N.MinusDown=0 Then
		DrawImageRect(CHGUI_Style,X,Y,OffX,OffY+20,20,20,0,(H)/20,(H)/20)
	Else If N.MinusDown Then
		DrawImageRect(CHGUI_Style,X,Y,OffX,OffY+40,20,20,0,(H)/20,(H)/20)
	Else 
		DrawImageRect(CHGUI_Style,X,Y,OffX,OffY,20,20,0,(H)/20,(H)/20)
	End If
	
	'Right Arrow
	If N.PlusOver And N.PlusDown=0 Then
		DrawImageRect(CHGUI_Style,X+W-H,Y,OffX+60,OffY+20,20,20,0,(H)/20,(H)/20)
	Else If N.PlusDown Then
		DrawImageRect(CHGUI_Style,X+W-H,Y,OffX+60,OffY+40,20,20,0,(H)/20,(H)/20)
	Else 
		DrawImageRect(CHGUI_Style,X+W-H,Y,OffX+60,OffY,20,20,0,(H)/20,(H)/20)
	End If
		
	
	'Middle
	DrawImageRect(CHGUI_Style,X+H,Y,OffX+20,OffY,40,20,0,(W-H-H)/40,(H)/20)
	
	'Slider
	Local XOF = 475
	Local YOF = 100
	If N.SliderOver And N.SliderDown=0 Then YOF = YOF + 20
	If N.SliderDown Then YOF = YOF + 40
	If Active = 0 Then YOF = YOF + 60
	Local XPOS:Float = X+H-5 + ((N.Value - N.Minimum) * N.Stp)
	
	DrawImageRect(CHGUI_Style,XPOS,Y,XOF,YOF,5,20,0,1,(H)/20)
	DrawImageRect(CHGUI_Style,XPOS+5,Y,XOF+5,YOF,40,20,0,(N.SWidth-10)/40,(H)/20)
	DrawImageRect(CHGUI_Style,XPOS+N.SWidth-5,Y,XOF+45,YOF,5,20,0,1,(H)/20)
	
End Function

Function CHGUI_DrawVSlider(N:CHGUI)
	Local X:Float = CHGUI_RealX(N)
	Local Y:Float = CHGUI_RealY(N)
	Local W:Float = N.W
	Local H:Float = N.H
	Local Active=CHGUI_RealActive(N)
	
	Local OffX = 370
	Local OffY = 10

	If Active = 0 Then OffX = 430
	
	'Left Arrow
	If N.MinusOver And N.MinusDown=0 Then
		DrawImageRect(CHGUI_Style,X,Y,OffX+20,OffY,20,20,0,(W)/20,(W)/20)
	Else If N.MinusDown Then
		DrawImageRect(CHGUI_Style,X,Y,OffX+40,OffY,20,20,0,(W)/20,(W)/20)
	Else 
		DrawImageRect(CHGUI_Style,X,Y,OffX,OffY,20,20,0,(W)/20,(W)/20)
	End If
	
	'Right Arrow
	If N.PlusOver And N.PlusDown=0 Then
		DrawImageRect(CHGUI_Style,X,Y+H-W,OffX+20,OffY+60,20,20,0,(W)/20,(W)/20)
	Else If N.PlusDown Then
		DrawImageRect(CHGUI_Style,X,Y+H-W,OffX+40,OffY+60,20,20,0,(W)/20,(W)/20)
	Else 
		DrawImageRect(CHGUI_Style,X,Y+H-W,OffX,OffY+60,20,20,0,(W)/20,(W)/20)
	End If
		
	
	'Middle
	DrawImageRect(CHGUI_Style,X,Y+W,OffX,OffY+20,20,40,0,(W)/20,(H-W-W)/40)
	
	'Slider
	Local XOF = 370
	Local YOF = 100
	If N.SliderOver And N.SliderDown=0 Then XOF = XOF + 20
	If N.SliderDown Then XOF = XOF + 40
	If Active = 0 Then XOF = XOF + 60
	Local YPOS:Float = Y+W-5 + ((N.Value-N.Minimum) * N.Stp)
	
	DrawImageRect(CHGUI_Style,X,YPOS,XOF,YOF,20,5,0,(W)/20,1)
	DrawImageRect(CHGUI_Style,X,YPOS+5,XOF,YOF+5,20,40,0,(W)/20,(N.SWidth-10)/40)
	DrawImageRect(CHGUI_Style,X,YPOS+N.SWidth-5,XOF,YOF+45,20,5,0,(W)/20,1)
	
End Function

Function CHGUI_DrawTextfield(N:CHGUI)
	Local X:Float = CHGUI_RealX(N)
	Local Y:Float = CHGUI_RealY(N)
	Local W:Float = N.W
	Local H:Float = N.H
	Local Active=CHGUI_RealActive(N)
	
	Local OffX = 280
	Local OffY = 10
	Local OffH = 40
	
	If N.Over Then  OffY = 50
	If N.Down And N.OnFocus=0 Then OffY = 90
	If  CHGUI_RealActive(N) =0 Then OffY = 130
		'TopLeft
		DrawImageRect(CHGUI_Style,X,Y,OffX,OffY,10,10,0,1,1)
		'Top
		DrawImageRect(CHGUI_Style,X+10,Y,OffX+10,OffY,20,10,0,(W-20)/20,1)
		'TopRight
		DrawImageRect(CHGUI_Style,X+W-10,Y,OffX+30,OffY,10,10,0,1,1)
		'Left
		DrawImageRect(CHGUI_Style,X,Y+10,OffX,OffY+10,10,20,0,1,(H-20)/20)
		'Right
		DrawImageRect(CHGUI_Style,X+W-10,Y+10,OffX+30,OffY+10,10,20,0,1,(H-20)/20)
		'Middle
		DrawImageRect(CHGUI_Style,X+10,Y+10,OffX+10,OffY+10,20,20,0,(W-20)/20,(H-20)/20)
		'Bottom Left
		DrawImageRect(CHGUI_Style,X,Y+H-10,OffX,OffY+30,10,10,0,1,1)
		'Bottom 
		DrawImageRect(CHGUI_Style,X+10,Y+H-10,OffX+10,OffY+30,20,10,0,(W-20)/20,1)
		'Bottom Right
		DrawImageRect(CHGUI_Style,X+W-10,Y+H-10,OffX+30,OffY+30,10,10,0,1,1)
		
	'Draw the label
	Local YOff:Float =( H - CHGUI_TextHeight(CHGUI_Font,N.Text))/2
	SetAlpha 0.25
	If Active Then SetAlpha 1
	CHGUI_Font.DrawText(N.Text,X+5,Y+YOff)
	SetAlpha 1
	
	'Draw the cursor
	If N.OnFocus
		Local Before:String = N.Text[..N.Cursor]
		Local Length = (CHGUI_Font.GetTxtWidth(Before+"NOT"))-CHGUI_Font.GetTxtWidth("NOT")
		If CHGUI_Cursor
			SetColor 0,0,0
			DrawLine(X+Length+8,Y+YOff,X+Length+8,Y+YOff+CHGUI_TextHeight(CHGUI_Font,N.Text))
			SetColor 255,255,255
		End If
	End If
End Function

Function CHGUI_DrawTab(N:CHGUI,Offset)
	N.X = Offset
	N.W = 20 + CHGUI_Font.GetTxtWidth(N.Text)
	N.H = 10 + CHGUI_TextHeight(CHGUI_Font,N.Text)
	N.Parent.Tabbed = 1
	N.Parent.TabHeight = N.H
	N.Y = 5
	If N.Parent.Text <> "" Then N.Y = N.Y + CHGUI_TitleHeight
	If N.Parent.HasMenu Then N.Y = N.Y + N.Parent.MenuHeight
	
	Local X:Float = CHGUI_RealX(N)
	Local Y:Float = CHGUI_RealY(N)
	Local W:Float = N.W
	Local H:Float = N.H
	Local Active=CHGUI_RealActive(N)
	
	Local OffX = 10
	Local OffY = 180
	If N.Parent.CurrentTab = N Then
		OffX = 70
		OffY = 180
	End If
	If N.Down Then
		OffX = 10
		OffY = 210
	End If
	If N.Over And N.Down=0 And N.Parent.CurrentTab <> N Then
		OffX = 40
		OffY = 180
	End If

	If Active = 0 Then
		OffX = 40
		OffY = 210
	End If
	
	
	
	Local YY = Y
	
	'TopLeft
	DrawImageRect(CHGUI_Style,X,YY,OffX,OffY,10,10)
	'TopRight
	DrawImageRect(CHGUI_Style,X+W-10,YY,OffX+20,OffY,10,10)
	'TopMiddle
	DrawImageRect(CHGUI_Style,X+10,YY,OffX+10,OffY,10,10,0,(W-20)/10,1)
	'Left
	DrawImageRect(CHGUI_Style,X,YY+10,OffX,OffY+10,10,10,0,1,(N.Parent.TabHeight-10)/10)
	'Right
	DrawImageRect(CHGUI_Style,X+W-10,YY+10,OffX+20,OffY+10,10,10,0,1,(N.Parent.TabHeight-10)/10)
	'Middle
	DrawImageRect(CHGUI_Style,X+10,YY+10,OffX+10,OffY+10,10,10,0,(W-20)/10,(N.Parent.TabHeight-10)/10)
	
	'BottomLeft
	DrawImageRect(CHGUI_Style,X,YY+N.Parent.TabHeight-10,OffX,OffY+20,10,10)
	'BottomRight
	DrawImageRect(CHGUI_Style,X+W-10,YY+N.Parent.TabHeight-10,OffX+20,OffY+20,10,10)
	'BottomMiddle
	DrawImageRect(CHGUI_Style,X+10,YY+N.Parent.TabHeight-10,OffX+10,OffY+20,10,10,0,(W-20)/10,1)
	
	'Draw the Text
	Local XOff:Float = ((W)-(CHGUI_Font.GetTxtWidth(N.Text)))/2
	Local YOff:Float =( N.Parent.TabHeight - CHGUI_TextHeight(CHGUI_Font,N.Text))/2
	SetAlpha 0.25
	If Active Then SetAlpha 1
	CHGUI_Font.DrawText(N.Text,X+XOff,YY+YOff)
	SetAlpha 1
End Function

Function CHGUI_DrawListbox(N:CHGUI)
	Local X:Float = CHGUI_RealX(N)
	Local Y:Float = CHGUI_RealY(N)
	Local W:Float = N.W
	Local H:Float = N.H
	Local Active=CHGUI_RealActive(N)
	N.ListboxSlider.X = N.X+W-17
	N.ListboxSlider.Y = N.ListboxSlider.Parent.Y + N.Y - N.Parent.Y
	N.ListboxSlider.H = N.H
	Local OffX = 90
	Local OffY = 80

	
	'TopLeft
	DrawImageRect(CHGUI_Style,X,Y,OffX,OffY,10,10)
	'TopMiddle
	DrawImageRect(CHGUI_Style,X+10,Y,OffX+10,OffY,40,10,0,(W-20)/40,1)
	'TopRight
	DrawImageRect(CHGUI_Style,X+W-10,Y,OffX+50,OffY,10,10)	
	'Left
	DrawImageRect(CHGUI_Style,X,Y+10,OffX,OffY+10,10,10,0,1,(H-20)/10)
	'Right
	DrawImageRect(CHGUI_Style,X+W-10,Y+10,OffX+50,OffY+10,10,10,0,1,(H-20)/10)
	'Middle
	DrawImageRect(CHGUI_Style,X+10,Y+10,OffX+10,OffY+10,40,10,0,(W-20)/40,(H-20)/10)
	'BottomLeft
	DrawImageRect(CHGUI_Style,X,Y+H-10,OffX,OffY+20,10,10)
	'BottomMiddle
	DrawImageRect(CHGUI_Style,X+10,Y+H-10,OffX+10,OffY+20,40,10,0,(W-20)/40,1)	
	'BottomLeft
	DrawImageRect(CHGUI_Style,X+W-10,Y+H-10,OffX+50,OffY+20,10,10)
	
	
End Function

Function CHGUI_DrawListboxItem(N:CHGUI, C)
	N.X = 0
	N.Y = (C) * N.Parent.ListHeight
	N.W = N.Parent.W
	N.H = N.Parent.ListHeight
	
	Local X:Float = CHGUI_RealX(N)
	Local Y:Float = CHGUI_RealY(N) 
	Local W:Float = N.W
	Local H:Float = N.H
	Local Active=CHGUI_RealActive(N)
	
	If N.Over = 1 Or N.Down Or N.Parent.SelectedListboxItem=N Then
		
		Local OffX = 90
		Local OffY = 110
		If N.Down Or N.Parent.SelectedListboxItem=N Then
			OffX = 90
			OffY = 140
		End If
	
		'TopLeft
		DrawImageRect(CHGUI_Style,X,Y,OffX,OffY,10,10)
		'TopMiddle
		DrawImageRect(CHGUI_Style,X+10,Y,OffX+10,OffY,40,10,0,(W-20)/40,1)
		'TopRight
		DrawImageRect(CHGUI_Style,X+W-10,Y,OffX+50,OffY,10,10)	
		'Left
		DrawImageRect(CHGUI_Style,X,Y+10,OffX,OffY+10,10,10,0,1,(H-20)/10)
		'Right
		DrawImageRect(CHGUI_Style,X+W-10,Y+10,OffX+50,OffY+10,10,10,0,1,(H-20)/10)
		'Middle
		DrawImageRect(CHGUI_Style,X+10,Y+10,OffX+10,OffY+10,40,10,0,(W-20)/40,(H-20)/10)
		'BottomLeft
		DrawImageRect(CHGUI_Style,X,Y+H-10,OffX,OffY+20,10,10)
		'BottomMiddle
		DrawImageRect(CHGUI_Style,X+10,Y+H-10,OffX+10,OffY+20,40,10,0,(W-20)/40,1)	
		'BottomLeft
		DrawImageRect(CHGUI_Style,X+W-10,Y+H-10,OffX+50,OffY+20,10,10)
		
	End If

	'Draw the Text
	Local YOff:Float = (H - CHGUI_TextHeight(CHGUI_Font,N.Text))/2
	SetAlpha 0.25
	If Active Then SetAlpha 1
		CHGUI_Font.DrawText(N.Text,X+10,Y+YOff)
	SetAlpha 1
	
	
End Function

Function CHGUI_DrawTooltip(N:CHGUI)
	Local X = CHGUI_RealX(N) + N.W
	Local Y = CHGUI_RealY(N) + N.H
	Local W = CHGUI_TooltipFont.GetTxtWidth(N.Tooltip) + 10
	Local H = CHGUI_TooltipFont.GetTxtHeight(N.Tooltip) + 10
	If X + W > DeviceWidth() Then X = DeviceWidth() - W
	If Y+H > DeviceHeight() Then Y = CHGUI_RealY(N) - H
	SetColor 100,100,100
	DrawRect X,Y,W,H
	SetColor 250,250,210
	DrawRect X+1,Y+1,W-2,H-2
	SetColor 255,255,255
	CHGUI_TooltipFont.DrawText(N.Tooltip,X+5,Y+5)
	SetColor 255,255,255
End Function

'#EndRegion 

'Setup CHGUI
Function CHGUI_Start()
	If CHGUI_Width = 0 Then CHGUI_Width = DeviceWidth()
	If CHGUI_Height = 0 Then CHGUI_Height = DeviceHeight()
	CHGUI_CanvasFlag=1
	CHGUI_Canvas = CreateWindow(0,0,CHGUI_Width,CHGUI_Height,"",0,0,0,0,Null)
	CHGUI_CanvasFlag=0
	If CHGUI_Style = Null Then CHGUI_Style = LoadImage("GUI_mac.png")
	CHGUI_ShadowImg = LoadImage("Shadow.png")
	If CHGUI_MobileMode = 0 Then
		If CHGUI_TitleFont = Null Then CHGUI_TitleFont = BitmapFont.Load("Arial10B.txt",True)
		If CHGUI_Font = Null Then CHGUI_Font = BitmapFont.Load("Arial12.txt",True)
	Else
		If CHGUI_TitleFont = Null Then CHGUI_TitleFont = BitmapFont.Load("Arial20B.txt",True)
		If CHGUI_Font = Null Then CHGUI_Font = BitmapFont.Load("Arial22.txt",True)
		CHGUI_TitleHeight = 50
	End If
	CHGUI_CreateKeyboard()
	CHGUI_MsgBoxWindow = CreateWindow(100,100,200,100,"Message box",0,0,0,2)
	CHGUI_MsgBoxLabel = CreateLabel(100,50,"Message text",CHGUI_MsgBoxWindow)
	CHGUI_MsgBoxButton = CreateButton(150,70,100,25,"Ok",CHGUI_MsgBoxWindow)
	CHGUI_MsgBoxWindow.Visible = 0
	CHGUI_TooltipFont = BitmapFont.Load("Arial10.txt",True)
	
End Function

'#Region "Keyboard Stuff"
Function CHGUI_CreateKeyButton:CHGUI(X, Y, W, H, Text:String, Parent:CHGUI = CHGUI_KeyboardWindow)
	Local N:CHGUI = New CHGUI
	N.Parent = Parent
	If Parent = Null Then N.Parent = CHGUI_Canvas
	N.X = X
	N.Y = Y
	N.W = W
	N.H = H
	N.Text = Text
	'Add to List
	N.Parent.Buttons = N.Parent.Buttons.Resize(N.Parent.Buttons.Length + 1)
	N.Parent.Buttons[N.Parent.Buttons.Length - 1] = N
	Return N
End Function

Function CHGUI_CreateKeyboard()
	CHGUI_KeyboardWindow = CreateWindow(0,0,DeviceWidth(),100,"",0,0,0,2)
	Local KeyWidth:Float = DeviceWidth()/12.5
	Local KeyHeight:Float = DeviceWidth()/12.5
	
	Local GapX:Float = (KeyWidth*2)/9
	Local GapY:Float = (KeyWidth*2)/9
	'Landscape
	If DeviceWidth() > DeviceHeight() Then
		KeyHeight = KeyHeight / 1.7
		GapY=GapY/1.2
	Else
		KeyHeight = KeyHeight * 1.5
		GapY=GapY*1.2
	End If
	
	
	Local EndGap:Float = (DeviceWidth() - (KeyWidth*10) - (GapX*9) )/2
	CHGUI_KeyboardWindow.H = (EndGap*2) + (GapY*3) + (KeyHeight*4)
	CHGUI_KeyboardWindow.Y = DeviceHeight() - CHGUI_KeyboardWindow.H
	
	
	Local SX:Float = EndGap
	Local SY:Float = EndGap
	
	'LOWERCASE KEYS
	CHGUI_KeyboardButtons[0] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"q")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[1] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"w")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[2] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"e")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[3] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"r")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[4] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"t")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[5] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"y")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[6] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"u")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[7] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"i")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[8] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"o")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[9] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"p")
	SX = EndGap+(KeyWidth/2)
	SY = SY + KeyHeight + GapY
	CHGUI_KeyboardButtons[10] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"a")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[11] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"s")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[12] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"d")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[13] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"f")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[14] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"g")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[15] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"h")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[16] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"j")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[17] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"k")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[18] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"l")
	SX = EndGap+(KeyWidth/2)+GapX+KeyWidth
	SY = SY + KeyHeight + GapY
	CHGUI_KeyboardButtons[19] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"z")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[20] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"x")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[21] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"c")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[22] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"v")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[23] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"b")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[24] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"n")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[25] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"m")
	
	SX = EndGap
	SY = EndGap
	
	'UPPERCASE KEYS
	CHGUI_KeyboardButtons[26] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"Q")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[27] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"W")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[28] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"E")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[29] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"R")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[30] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"T")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[31] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"Y")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[32] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"U")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[33] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"I")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[34] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"O")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[35] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"P")
	SX = EndGap+(KeyWidth/2)
	SY = SY + KeyHeight + GapY
	CHGUI_KeyboardButtons[36] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"A")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[37] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"S")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[38] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"D")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[39] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"F")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[40] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"G")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[41] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"H")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[42] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"J")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[43] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"K")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[44] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"L")
	SX = EndGap+(KeyWidth/2)+GapX+KeyWidth
	SY = SY + KeyHeight + GapY
	CHGUI_KeyboardButtons[45] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"Z")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[46] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"X")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[47] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"C")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[48] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"V")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[49] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"B")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[50] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"N")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[51] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"M")
	
	
	SX = EndGap
	SY = EndGap
	
	'NUMBER KEYS PANEL
	CHGUI_KeyboardButtons[52] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"1")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[53] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"2")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[54] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"3")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[55] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"4")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[56] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"5")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[57] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"6")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[58] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"7")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[59] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"8")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[60] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"9")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[61] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"0")
	SX = EndGap+(KeyWidth/2)
	SY = SY + KeyHeight + GapY
	CHGUI_KeyboardButtons[62] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"-")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[63] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"/")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[64] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"\")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[65] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,":")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[66] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,";")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[67] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"(")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[68] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,")")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[69] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"£")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[70] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"&")
	SX = EndGap+(KeyWidth/2)+GapX+KeyWidth
	SY = SY + KeyHeight + GapY
	CHGUI_KeyboardButtons[71] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"@")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[72] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,".")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[73] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,",")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[74] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"?")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[75] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"!")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[76] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"'")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[77] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,String.FromChar(34))
	
	
		SX = EndGap
	SY = EndGap
	
	'SYMBOLS KEYS PANEL
	CHGUI_KeyboardButtons[78] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"[")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[79] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"]")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[80] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"{")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[81] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"}")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[82] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"#")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[83] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"%")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[84] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"^")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[85] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"*")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[86] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"+")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[87] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"=")
	SX = EndGap+(KeyWidth/2)
	SY = SY + KeyHeight + GapY
	CHGUI_KeyboardButtons[88] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"_")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[89] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"|")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[90] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"~")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[91] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"<")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[92] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,">")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[93] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"$")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[94] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"€")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[95] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"é")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[96] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"¬")
	SX = EndGap+(KeyWidth/2)+GapX+KeyWidth
	SY = SY + KeyHeight + GapY
	CHGUI_KeyboardButtons[97] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"@")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[98] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,".")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[99] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,",")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[100] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"?")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[101] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"!")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[102] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,"'")
	SX = SX + KeyWidth + GapX
	CHGUI_KeyboardButtons[103] = CHGUI_CreateKeyButton(SX,SY,KeyWidth,KeyHeight,String.FromChar(34))
	
	'STD EDITOR KEYS
	SX = EndGap
	SY = EndGap+KeyHeight+GapY+ KeyHeight + GapY
	CHGUI_KeyboardButtons[104] = CHGUI_CreateKeyButton(SX,SY,KeyWidth+(KeyWidth/2),KeyHeight,"Shft")
	SX = EndGap + (KeyWidth*9) +(GapX*9) - KeyWidth/2 - GapX
	SY = EndGap+KeyHeight+GapY+ KeyHeight + GapY
	CHGUI_KeyboardButtons[105] = CHGUI_CreateKeyButton(SX,SY,KeyWidth+(KeyWidth/2),KeyHeight,"<--")
	SX = EndGap
	SY = SY + KeyHeight + GapY
	CHGUI_KeyboardButtons[106] = CHGUI_CreateKeyButton(SX,SY,KeyWidth*2+(KeyWidth/2)+GapX,KeyHeight,"123")
	SX = SX+KeyWidth*2+(KeyWidth/2)+GapX+GapX
	CHGUI_KeyboardButtons[107] = CHGUI_CreateKeyButton(SX,SY,KeyWidth*5+(GapX*4),KeyHeight," ")
	SX = SX+KeyWidth*5+(GapX*5)
	CHGUI_KeyboardButtons[108] = CHGUI_CreateKeyButton(SX,SY,KeyWidth*2+(KeyWidth/2)+GapX,KeyHeight,"Enter")
	
	For Local C = 0 to 108
		CHGUI_KeyboardButtons[C].Visible = 0
	Next
	CHGUI_KeyboardWindow.Visible = 0
End Function

Function CHGUI_UpdateKeyboard(N:CHGUI)
	'PutKeyboard onTop
	CHGUI_Reorder(CHGUI_KeyboardWindow)
	
	CHGUI_UpdateKeyboardSizes()
		
	'Update the position of the Keyboard
	CHGUI_KeyboardWindow.X = 0-CHGUI_OffsetX
	CHGUI_KeyboardWindow.Y = DeviceHeight()-CHGUI_KeyboardWindow.H-CHGUI_OffsetY
		
	'Make the shift active / inactive
	If CHGUI_KeyboardPage > 1 Then
		CHGUI_KeyboardButtons[104].Active = 0
	Else
		CHGUI_KeyboardButtons[104].Active = 1
	End If
	
	'FORMAT OPTIONS
		'All Active
		For Local C = 0 to 108
			CHGUI_KeyboardButtons[C].Active = 1
		Next
		' Page button Active
		CHGUI_KeyboardButtons[106].Active = 1
		' Shiftbutton Active
		CHGUI_KeyboardButtons[104].Active = 1
		' Space Active
		CHGUI_KeyboardButtons[107].Active = 1
		
	'No Space
	If N.FormatSpace =0 Then CHGUI_KeyboardButtons[107].Active = 0
	
	
	'Text Only
	If N.FormatText=1 And N.FormatNumber=0 And N.FormatSymbol=0 Then
		If CHGUI_KeyboardPage > 1 Then CHGUI_KeyboardPage = 0
		CHGUI_KeyboardButtons[106].Active = 0
	End If
	'Numbers Only
	If N.FormatNumber=1 And N.FormatText=0 And N.FormatSymbol=0 Then
		CHGUI_KeyboardPage = 2
		CHGUI_KeyboardButtons[106].Active = 0
		CHGUI_KeyboardButtons[104].Active = 0
		For Local C = 62 to 77
			CHGUI_KeyboardButtons[C].Active = 0
		Next
	End If
	'Symbols Only
	If N.FormatNumber=0 And N.FormatText=0 And N.FormatSymbol=1 Then
		If CHGUI_KeyboardPage < 2 CHGUI_KeyboardPage = 2
		CHGUI_KeyboardButtons[104].Active = 0
		For Local C = 52 to 61
			CHGUI_KeyboardButtons[C].Active = 0
		Next
	End If
	'Text And Numbers Only
	If N.FormatText=1 And N.FormatNumber=1 And N.FormatSymbol=0 Then
		If CHGUI_KeyboardPage > 2 Then CHGUI_KeyboardPage = 0
		For Local C = 62 to 77
			CHGUI_KeyboardButtons[C].Active = 0
		Next
	End If
	'Text And Symbols Only
	If N.FormatText=1 And N.FormatNumber=0 And N.FormatSymbol=1 Then
		For Local C = 52 to 61
			CHGUI_KeyboardButtons[C].Active = 0
		Next
	End If
	'Symbols And Numbers Only
	If N.FormatText=0 And N.FormatNumber=1 And N.FormatSymbol=1 Then
		If CHGUI_KeyboardPage <2 Then CHGUI_KeyboardPage = 2
		CHGUI_KeyboardButtons[104].Active = 0
	End If	
		
		
		
	If CHGUI_KeyboardPage > 1 Then CHGUI_KeyboardButtons[104].Active = 0
	
	
	
	
	
	'Toggle Shift
	If CHGUI_KeyboardPage < 2 Then
		If CHGUI_KeyboardButtons[104].Clicked Then
			If CHGUI_KeyboardShift = 0 Then
				CHGUI_KeyboardShift = 1
				CHGUI_KeyboardPage = 1
				CHGUI_ShiftHold = 0
			Else
				CHGUI_KeyboardShift = 0
				CHGUI_KeyboardPage = 0
				CHGUI_ShiftHold = 0
			End If
		End If
		
		If CHGUI_KeyboardButtons[104].DoubleClicked Then
			CHGUI_ShiftHold = 1
			CHGUI_KeyboardShift = 1
			CHGUI_KeyboardPage = 1
		End If
	End If
	
	'Toggle Pages
	If CHGUI_KeyboardButtons[106].Clicked Then
		If CHGUI_KeyboardPage=0 Then
			CHGUI_KeyboardPage = 2
			CHGUI_KeyboardButtons[104].Active = 0
		Else If CHGUI_KeyboardPage=1 Then
			CHGUI_KeyboardPage = 2
			CHGUI_KeyboardButtons[104].Active = 0
		Else If CHGUI_KeyboardPage=2 Then
			CHGUI_KeyboardPage = 3
			CHGUI_KeyboardButtons[104].Active = 0
		Else If CHGUI_KeyboardPage=3 Then
			CHGUI_KeyboardPage = 0
			CHGUI_KeyboardShift = 0
		End If
	End If
	
	
	'Page Button Text
	If CHGUI_KeyboardPage=0 or CHGUI_KeyboardPage=1 Then
		If N.FormatNumber = 1 Then
			CHGUI_KeyboardButtons[106].Text = "123"
		Else
			CHGUI_KeyboardButtons[106].Text = "#+="
		End If
	End If
	
	If CHGUI_KeyboardPage=2 Then
		If N.FormatSymbol = 1 Then
			CHGUI_KeyboardButtons[106].Text = "#+="
		Else
			CHGUI_KeyboardButtons[106].Text = "Abc"
		End If
	End If
	
	If CHGUI_KeyboardPage=3 Then
		If N.FormatText = 1 Then
			CHGUI_KeyboardButtons[106].Text = "#+="
		ElseIf N.FormatNumber = 1
			CHGUI_KeyboardButtons[106].Text = "123"
		Else
			CHGUI_KeyboardButtons[106].Text = "#+="
		End If
	End If
	
	

	'Make all keys invisible
	For Local C = 0 to 108
		CHGUI_KeyboardButtons[C].Visible = 0
	Next
	'Make the right keys appear
	If CHGUI_KeyboardPage = 0 Then
		For Local C = 0 to 25
			CHGUI_KeyboardButtons[C].Visible = 1
		Next
	End If
	If CHGUI_KeyboardPage = 1 Then
		For Local C = 26 to 51
			CHGUI_KeyboardButtons[C].Visible = 1
		Next
	End If
	If CHGUI_KeyboardPage = 2 Then
		For Local C = 52 to 77
			CHGUI_KeyboardButtons[C].Visible = 1
		Next
	End If
	If CHGUI_KeyboardPage = 3 Then
		For Local C = 78 to 103
			CHGUI_KeyboardButtons[C].Visible = 1
		Next
	End If
	For Local C = 104 to 108
			CHGUI_KeyboardButtons[C].Visible = 1
	Next
	
	'KEYBOARD INPUT
	
	Local Before:String = N.Text[..N.Cursor]
	Local After:String = N.Text[N.Cursor..]
	
	'Any text key
	For Local C1 = 0 to 103
		If CHGUI_KeyboardButtons[C1].Clicked And CHGUI_Font.GetTxtWidth(N.Text) < N.W -12 Then
			Before = Before + CHGUI_KeyboardButtons[C1].Text
			N.Cursor = N.Cursor + 1
			If CHGUI_ShiftHold = 0 Then
				If CHGUI_KeyboardPage = 0 Or CHGUI_KeyboardPage = 1 Then 
					CHGUI_KeyboardShift = 0 ; CHGUI_KeyboardPage = 0
				End If
			End If
		End If
	Next
	'BackSpace
	If CHGUI_KeyboardButtons[105].Down
		If CHGUI_KeyboardButtons[105].DKeyMillisecs < Millisecs()
			CHGUI_KeyboardButtons[105].DKeyMillisecs = Millisecs() + 150
			Before = Before [..(Before.Length-1)]
			If N.Cursor > 0 Then N.Cursor = N.Cursor-1
		End If
	End If
	'Space
	If CHGUI_KeyboardButtons[107].Clicked And CHGUI_Font.GetTxtWidth(N.Text) < N.W -12 Then
		Before = Before + " "
		N.Cursor = N.Cursor + 1
	End If
	'Enter
	If CHGUI_KeyboardButtons[108].Clicked
		N.OnFocus = 0
		CHGUI_KeyboardWindow.Visible = 0
		CHGUI_KeyboardPage = 0
		If CHGUI_AutoTextScroll = 1 Then
			CHGUI_TargetX = CHGUI_OldX
			CHGUI_TargetY = CHGUI_OldY
			CHGUI_Moving = 1
		End If
	End If
	
	N.Text = Before + After
End Function	

Function CHGUI_UpdateKeyboardSizes()
	Local KeyWidth:Float = DeviceWidth()/12.5
	Local KeyHeight:Float = DeviceWidth()/12.5
	
	Local GapX:Float = (KeyWidth*2)/9
	Local GapY:Float = (KeyWidth*2)/9
	'Landscape
	If DeviceWidth() > DeviceHeight() Then
		KeyHeight = KeyHeight / 1.7
		GapY=GapY/1.2
	Else
		KeyHeight = KeyHeight * 1.5
		GapY=GapY*1.2
	End If
	
	
	Local EndGap:Float = (DeviceWidth() - (KeyWidth*10) - (GapX*9) )/2
	
	CHGUI_KeyboardWindow.H = (EndGap*2) + (GapY*3) + (KeyHeight*4)
	CHGUI_KeyboardWindow.Y = DeviceHeight() - CHGUI_KeyboardWindow.H
	CHGUI_KeyboardWindow.W = DeviceWidth()
	
	Local SX:Float = EndGap
	Local SY:Float = EndGap
	
	For Local C = 0 to 9
		CHGUI_KeyboardButtons[C].X = SX
		CHGUI_KeyboardButtons[C].Y = SY
		CHGUI_KeyboardButtons[C].W = KeyWidth
		CHGUI_KeyboardButtons[C].H = KeyHeight	
		CHGUI_KeyboardButtons[C+26].X = SX
		CHGUI_KeyboardButtons[C+26].Y = SY
		CHGUI_KeyboardButtons[C+26].W = KeyWidth
		CHGUI_KeyboardButtons[C+26].H = KeyHeight
		CHGUI_KeyboardButtons[C+52].X = SX
		CHGUI_KeyboardButtons[C+52].Y = SY
		CHGUI_KeyboardButtons[C+52].W = KeyWidth
		CHGUI_KeyboardButtons[C+52].H = KeyHeight
		CHGUI_KeyboardButtons[C+78].X = SX
		CHGUI_KeyboardButtons[C+78].Y = SY
		CHGUI_KeyboardButtons[C+78].W = KeyWidth
		CHGUI_KeyboardButtons[C+78].H = KeyHeight
		SX = SX + GapX + KeyWidth
	Next
	
	SX = EndGap+(KeyWidth/2)
	SY = SY + KeyHeight + GapY
	
	For Local C = 10 to 18
		CHGUI_KeyboardButtons[C].X = SX
		CHGUI_KeyboardButtons[C].Y = SY
		CHGUI_KeyboardButtons[C].W = KeyWidth
		CHGUI_KeyboardButtons[C].H = KeyHeight
		CHGUI_KeyboardButtons[C+26].X = SX
		CHGUI_KeyboardButtons[C+26].Y = SY
		CHGUI_KeyboardButtons[C+26].W = KeyWidth
		CHGUI_KeyboardButtons[C+26].H = KeyHeight
		CHGUI_KeyboardButtons[C+52].X = SX
		CHGUI_KeyboardButtons[C+52].Y = SY
		CHGUI_KeyboardButtons[C+52].W = KeyWidth
		CHGUI_KeyboardButtons[C+52].H = KeyHeight
		CHGUI_KeyboardButtons[C+78].X = SX
		CHGUI_KeyboardButtons[C+78].Y = SY
		CHGUI_KeyboardButtons[C+78].W = KeyWidth
		CHGUI_KeyboardButtons[C+78].H = KeyHeight		
		SX = SX + GapX + KeyWidth
	Next
	
	SX = EndGap+(KeyWidth/2)+GapX+KeyWidth
	SY = SY + KeyHeight + GapY
	
	For Local C = 19 to 25
		CHGUI_KeyboardButtons[C].X = SX
		CHGUI_KeyboardButtons[C].Y = SY
		CHGUI_KeyboardButtons[C].W = KeyWidth
		CHGUI_KeyboardButtons[C].H = KeyHeight
		CHGUI_KeyboardButtons[C+26].X = SX
		CHGUI_KeyboardButtons[C+26].Y = SY
		CHGUI_KeyboardButtons[C+26].W = KeyWidth
		CHGUI_KeyboardButtons[C+26].H = KeyHeight
		CHGUI_KeyboardButtons[C+52].X = SX
		CHGUI_KeyboardButtons[C+52].Y = SY
		CHGUI_KeyboardButtons[C+52].W = KeyWidth
		CHGUI_KeyboardButtons[C+52].H = KeyHeight
		CHGUI_KeyboardButtons[C+78].X = SX
		CHGUI_KeyboardButtons[C+78].Y = SY
		CHGUI_KeyboardButtons[C+78].W = KeyWidth
		CHGUI_KeyboardButtons[C+78].H = KeyHeight		
		SX = SX + GapX + KeyWidth
	Next
		
	SX = EndGap
	SY = EndGap+KeyHeight+GapY+ KeyHeight + GapY
	CHGUI_KeyboardButtons[104].X =SX
	CHGUI_KeyboardButtons[104].Y =SY
	CHGUI_KeyboardButtons[104].W =KeyWidth+(KeyWidth/2)
	CHGUI_KeyboardButtons[104].H =KeyHeight
	
	
	SX = EndGap + (KeyWidth*9) +(GapX*9) - KeyWidth/2 - GapX
	SY = EndGap+KeyHeight+GapY+ KeyHeight + GapY
	CHGUI_KeyboardButtons[105].X =SX
	CHGUI_KeyboardButtons[105].Y =SY
	CHGUI_KeyboardButtons[105].W =KeyWidth+(KeyWidth/2)
	CHGUI_KeyboardButtons[105].H =KeyHeight
	
	SX = EndGap
	SY = SY + KeyHeight + GapY
	CHGUI_KeyboardButtons[106].X =SX
	CHGUI_KeyboardButtons[106].Y =SY
	CHGUI_KeyboardButtons[106].W =KeyWidth*2+(KeyWidth/2)+GapX
	CHGUI_KeyboardButtons[106].H =KeyHeight
	
	SX = SX+KeyWidth*2+(KeyWidth/2)+GapX+GapX
	CHGUI_KeyboardButtons[107].X =SX
	CHGUI_KeyboardButtons[107].Y =SY
	CHGUI_KeyboardButtons[107].W =KeyWidth*5+(GapX*4)
	CHGUI_KeyboardButtons[107].H =KeyHeight
	
	SX = SX+KeyWidth*5+(GapX*5)
	CHGUI_KeyboardButtons[108].X =SX
	CHGUI_KeyboardButtons[108].Y =SY
	CHGUI_KeyboardButtons[108].W =KeyWidth*2+(KeyWidth/2)+GapX
	CHGUI_KeyboardButtons[108].H =KeyHeight

End Function

'#EndRegion 


Function CHGUI_UpdateMsgBox()
	If CHGUI_MsgBoxWindow.Visible Then
		LockFocus(CHGUI_MsgBoxWindow)
		'Update Position
		CHGUI_MsgBoxWindow.X = (DeviceWidth()/2) - (CHGUI_MsgBoxWindow.W/2)
		CHGUI_MsgBoxWindow.Y = (DeviceHeight()/2) - (CHGUI_MsgBoxWindow.H/2)
		CHGUI_MsgBoxLabel.X = (CHGUI_MsgBoxWindow.W - CHGUI_Font.GetTxtWidth(CHGUI_MsgBoxLabel.Text))/2
		'Check click
		If CHGUI_MsgBoxButton.Clicked Then
			CHGUI_MsgBoxWindow.Visible = 0
			UnlockFocus()
		End If
	End If
End Function

'#Region Misc Functions
Function CHGUI_TextHeight:Float(Fnt:BitmapFont,Text:String)
	Local Split:String[] = Text.Split("~n")
	Local H:Float = Fnt.GetFontHeight
	Local Height:Float = 0
	For Local N = 0 to Split.Length-1
		Height = Height + H
	Next
	Return Height
End Function

Function CHGUI_RealX(N:CHGUI)
	Local E:CHGUI
	E = N
	Local X = N.X
	Repeat
		If E.Parent <> Null Then
			If E.Parent.Element <> "Tab" Then  
				X = X + E.Parent.X
				E = E.Parent
			Else
				E = E.Parent
			End If
		Else
			Exit
		End If
	Forever
	X = X + CHGUI_OffsetX
	Return X
End Function

Function CHGUI_RealY(N:CHGUI)
	Local E:CHGUI
	E = N
	Local Y = N.Y
	Repeat
		If E.Parent <> Null Then
			If E.Parent.Element <> "Tab" Then 
				Y = Y + E.Parent.Y
				E = E.Parent
			Else
				E = E.Parent
			End If
		Else
			Exit
		End If
	Forever
	Y = Y + CHGUI_OffsetY
	Return Y
End Function

Function CHGUI_RealVisible(N:CHGUI)
	Local E:CHGUI
	E = N
	Local V = N.Visible
	If V = 0 Then Return V
	Repeat
		If E.Parent <> Null Then
			V = E.Parent.Visible
			If V = 0 Then Exit
			E = E.Parent
		Else
			Exit
		End If
	Forever
	If CHGUI_Canvas.Visible = 0 Then V = 0
	Return V
End Function

Function CHGUI_RealActive(N:CHGUI)
	Local E:CHGUI
	E = N
	Local A = N.Active
	If A = 0 Then Return A
	Repeat
		If E = CHGUI_LockedWIndow Then Return 1
		If E.Parent <> Null Then
			If E.Parent = CHGUI_LockedWIndow Then
				Return 1
			End If
			A = E.Parent.Active
			If A = 0 Then Exit
			
			E = E.Parent
		Else
			Exit
		End If
	Forever
	'If CHGUI_Canvas.Active = 0 Then A = 0
	Return A
End Function

Function CHGUI_RealMinimised(N:CHGUI)
	Local E:CHGUI
	E = N
	Local M = E.Minimised
	If M = 1 Then Return M
	Repeat
		If E.Parent <> Null Then
			M = E.Parent.Minimised
			If M = 1 Then Exit
			E = E.Parent
		Else
			Exit
		End If
	Forever
	Return M
End Function

Function CHGUI_Reorder(Top:CHGUI)
	If Top.Mode = 1 Then CHGUI_ReorderSubWindows(Top)
	If Top.Mode = 2 Then CHGUI_ReorderSubWindows(Top)
End Function

Function CHGUI_ReorderSubWindows(Top:CHGUI)
	If Top.Parent.TopVari <> Top And Top.Mode=1 Then
			Local N
			For N = 0 to Top.Parent.VariList.Length-1
				If Top.Parent.VariList[N] = Top Then Exit
			Next
			For Local NN = N to Top.Parent.VariList.Length-2
				Top.Parent.VariList[NN] = Top.Parent.VariList[NN+1]
			Next
			Top.Parent.VariList[Top.Parent.VariList.Length-1] = Top 
			Top.Parent.TopVari = Top
	End If
	
	If Top.Parent.TopTop <> Top And Top.Mode = 2 Then
			Local N
			For N = 0 to Top.Parent.TopList.Length-1
				If Top.Parent.TopList[N] = Top Then Exit
			Next
			For Local NN = N to Top.Parent.TopList.Length-2
				Top.Parent.TopList[NN] = Top.Parent.TopList[NN+1]
			Next
			Top.Parent.TopList[Top.Parent.TopList.Length-1] = Top 
			Top.Parent.TopTop = Top
	End If
	
		If Top.Parent.TopBottom <> Top And Top.Mode = 0 Then
			Local N
			For N = 0 to Top.Parent.BottomList.Length-1
				If Top.Parent.BottomList[N] = Top Then Exit
			Next
			For Local NN = N to Top.Parent.BottomList.Length-2
				Top.Parent.BottomList[NN] = Top.Parent.BottomList[NN+1]
			Next
			Top.Parent.BottomList[Top.Parent.BottomList.Length-1] = Top 
			Top.Parent.TopBottom = Top
	End If

End Function

Function CHGUI_FPSUpdate()
	If Millisecs() > CHGUI_Millisecs Then
		CHGUI_Millisecs = Millisecs()+1000
		CHGUI_FPS = CHGUI_FPSCounter
		CHGUI_FPSCounter = 0
	End If
	CHGUI_FPSCounter = CHGUI_FPSCounter +1
End Function

Function CHGUI_Locked(N:CHGUI)
	Local E:CHGUI
	E = N
	If E = CHGUI_LockedWIndow Then Return 1
	Repeat
		If E.Parent <> Null Then
			If E.Parent = CHGUI_LockedWIndow Then Return 1
			E = E.Parent
		Else
			Return 0
		End If
	Forever
End Function
'#EndRegion 